searchNodes=[{"doc":"PrimerLive components can be used in Phoenix LiveView pages and regular (non-LiveView) views in Phoenix applications. The Primer Design System provides a strong base for creating data driven applications such as rich CRUD applications with interactive forms. Since this implementation closely adheres to the Primer CSS documentation , extending components with Primer's utility classes should be simple. Demo PrimerLive Storybook Source code PrimerLive at GitHub Installation Install primer_live Add PrimerLive as a dependency in your Phoenix application's mix.exs { :primer_live , &quot;~&gt; 0.2&quot; } Run mix.deps get Add CSS and JavaScript dependencies You can either use `npm`, or add the dependencies to the HTML file. If you plan to use menus, dialogs, or drawers in your project, you will need to include JavaScript dependencies. If not, you may skip the JavaScript imports and hooks. Option A: Adding dependencies using npm Add npm library primer-live to your assets/package.json . For a regular project, do: { &quot;dependencies&quot; : { &quot;primer-live&quot; : &quot;file:../deps/primer_live&quot; } } If you're adding primer-live to an umbrella project, change the paths accordingly: { &quot;dependencies&quot; : { &quot;primer-live&quot; : &quot;file:../../../deps/primer_live&quot; } } Now run the next command from your web app root: npm install -- prefix assets If you had previously installed primer-live and want to get the latest JavaScript, then force an install with: npm install -- force primer - live -- prefix assets To ensure that the assets are installed before your application has started, and before it has been deployed, add &quot;npm install&quot; to the setup and deploy scripts in mix.exs . For example: defp aliases do [ setup : [ &quot;deps.get&quot; , &quot;cmd npm --prefix assets install&quot; ] , &quot;assets.deploy&quot; : [ &quot;cmd npm --prefix assets install&quot; , &quot;esbuild default --minify&quot; , &quot;phx.digest&quot; ] ] end Run mix setup to install the npm dependencies. Add to assets/js/app.js : import &quot;primer-live/primer-live.min.css&quot; ; import { Prompt , Session } from &quot;primer-live&quot; ; Also in assets/js/app.js , add Prompt and Session to the hooks: let liveSocket = new LiveSocket ( &quot;/live&quot; , Socket , { params : { _csrf_token : csrfToken } , hooks : { Prompt , Session , // existing hooks ... } , } ) ; Option B: Adding dependencies to the HTML file Load the dependencies from a content delivery service such as unpkg. CSS only Add to root.html.heex : &lt; link rel = &quot;stylesheet&quot; href = &quot;https://unpkg.com/primer-live/priv/static/primer-live.min.css&quot; media = &quot;all&quot; &gt; CSS and JavaScript Add to root.html.heex : &lt; link rel = &quot;stylesheet&quot; href = &quot;https://unpkg.com/primer-live/priv/static/primer-live.min.css&quot; media = &quot;all&quot; &gt; &lt; script src = &quot;https://unpkg.com/primer-live/priv/static/primer-live.min.js&quot; &gt; &lt; / script &gt; In assets/js/app.js , add global Prompt and Session to the hooks: let liveSocket = new LiveSocket ( &quot;/live&quot; , Socket , { params : { _csrf_token : csrfToken } , hooks : { Prompt , Session , // existing hooks ... } , } ) ; Usage in LiveView pages To use components, use module PrimerLive : defmodule MyAppWeb.MyLiveView do use MyAppWeb , :live_view use PrimerLive def render ( assigns ) do ~H&quot;&quot;&quot; &lt;.button&gt;Click me&lt;/.button&gt; &quot;&quot;&quot; end end Usage in regular views In view files, for example in page_view.ex , use module PrimerLive : defmodule MyAppWeb.PageView do use MyAppWeb , :view use PrimerLive end Then call the component on a page, for example in templates/page/index.html.heex : &lt; . button &gt; Click me &lt; / . button &gt; List of components PrimerLive.Component","ref":"PrimerLive.html","title":"PrimerLive","type":"module"},{"doc":"PrimerLive components.","ref":"PrimerLive.Component.html","title":"PrimerLive.Component","type":"module"},{"doc":"Generates a vertical list of interactive actions or options. It’s composed of items presented in a consistent single-column format, with room for icons, descriptions, side information, and other rich visuals. Action list is composed of one or more child components: action_list_section_divider/1 - a divider with optional title action_list_item/1 - versatile list item See the Primer Action List interface guidelines for more examples. Examples action_list &lt; . action_list &gt; &lt; . action_list_item &gt; Item &lt; / . action_list_item &gt; &lt; . action_list_item &gt; Item &lt; / . action_list_item &gt; &lt; / . action_list &gt; Create separator lines between the items: &lt; . action_list is_divided &gt; ... &lt; / . action_list &gt; Remove default padding: &lt; . action_list is_full_bleed &gt; ... &lt; / . action_list &gt; action_list_section_divider Add a divider to separate a group of content: &lt; . action_list &gt; &lt; . action_list_section_divider / &gt; ... &lt; / . action_list &gt; Add a title to the divider, and optionally a description: &lt; . action_list &gt; &lt; . action_list_section_divider &gt; &lt; :title &gt; Section title &lt; / :title &gt; &lt; :description &gt; A descriptive text &lt; / :description &gt; &lt; / . action_list_section_divider &gt; ... &lt; / . action_list &gt; Use the title slot to set the id for aria-labelledby : &lt; . action_list aria - labelledby = &quot;title-01&quot; &gt; &lt; . action_list_section_divider &gt; &lt; :title id = &quot;title-01&quot; &gt; Section title &lt; / :title &gt; &lt; / . action_list_section_divider &gt; ... &lt; / . action_list &gt; action_list_item Common list item attributes: &lt; . action_list_item is_selected &gt; This is the selected item &lt; / . action_list_item &gt; &lt; . action_list_item is_danger &gt; Descructive item &lt; / . action_list_item &gt; &lt; . action_list_item is_disabled &gt; Disabled item &lt; / . action_list_item &gt; &lt; . action_list_item is_button phx - click = &quot;remove&quot; &gt; Button &lt; / . action_list_item &gt; &lt; . action_list_item is_height_medium &gt; A higher item &lt; / . action_list_item &gt; &lt; . action_list_item is_height_large &gt; An even higher item &lt; / . action_list_item &gt; &lt; . action_list_item is_truncated &gt; A very long text that should stay on one line , abbreviated by ellipsis &lt; / . action_list_item &gt; Use slot description to add a descriptive text. The description is displayed on a new line by default. &lt; . action_list_item &gt; Short label &lt; :description &gt; A more descriptive text &lt; / :description &gt; &lt; / . action_list_item &gt; Place the description on the same line: &lt; . action_list_item is_inline_description &gt; Short label &lt; :description &gt; A more descriptive text after the title &lt; / :description &gt; &lt; / . action_list_item &gt; Add a leading visual. This is usually an octicon/1 , but can be any small image: &lt; . action_list_item &gt; Item &lt; :leading_visual &gt; &lt; . octicon name = &quot;bell-16&quot; / &gt; &lt; / :leading_visual &gt; &lt; / . action_list_item &gt; Likewise, add a trailing visual: &lt; . action_list_item &gt; Item &lt; :leading_visual &gt; &lt; . counter &gt; 12 &lt; / . counter &gt; &lt; / :leading_visual &gt; &lt; / . action_list_item &gt; Items are by default rendered as span elements. To create link elements, place the label text inside slot link and pass attribute href , navigate or patch . When a link attribute is supplied to the link slot, links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; . action_list_item &gt; &lt; :link href = &quot;/url&quot; target = &quot;_blank&quot; &gt; href link &lt; / :link &gt; &lt; / . action_list_item &gt; &lt; . action_list_item &gt; &lt; :link navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :link &gt; &lt; / . action_list_item &gt; &lt; . action_list_item &gt; &lt; :link patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :link &gt; &lt; / . action_list_item &gt; Action list items can be selected. Single selections are represented with a check ui_icon/1 , while multiple selections are represented with a checkbox ui_icon/1 . Create a single select list: &lt; . action_list &gt; &lt; . action_list_item is_single_select is_selected &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_single_select &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_single_select &gt; Option &lt; / . action_list_item &gt; &lt; / . action_list &gt; Create a multiple select list: &lt; . action_list &gt; &lt; . action_list_item is_multiple_select is_selected &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_multiple_select is_selected &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_multiple_select &gt; Option &lt; / . action_list_item &gt; &lt; / . action_list &gt; Deviating from the Primer implementation, selected items don't show a highlight border at the left. To give these items a navigation like appearance, use is_selected_link_marker : &lt; . action_list &gt; &lt; . action_list_item is_single_select is_selected_link_marker is_selected &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_single_select is_selected_link_marker &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_single_select is_selected_link_marker &gt; Option &lt; / . action_list_item &gt; &lt; / . action_list &gt; Nested sub lists (&quot;sub groups&quot;) can be used to initially hide additional options. A sub group is an action list placed inside a list item, which is automatically created by slot sub_group . &lt; . action_list &gt; &lt; . action_list_section_divider &gt; &lt; :title &gt; Section title &lt; / :title &gt; &lt; / . action_list_section_divider &gt; &lt; . action_list_item leading_visual_width = &quot;16&quot; is_collapsible is_expanded &gt; Collapsible and expanded item &lt; :leading_visual &gt; &lt; . octicon name = &quot;comment-discussion-16&quot; / &gt; &lt; / :leading_visual &gt; &lt; :sub_group &gt; &lt; . action_list_item is_sub_item &gt; Sub item &lt; / . action_list_item &gt; &lt; . action_list_item is_sub_item &gt; Sub item &lt; / . action_list_item &gt; &lt; / :sub_group &gt; &lt; / . action_list_item &gt; &lt; / . action_list &gt; slot sub_group accepts action_list/1 attributes is_collapsible indicates that the sub group is conditionally hidden. The item is rendered as button. is_expanded reveals hidden items. leading_visual_width can be used to align the content with the visual. action list attribute is_sub_item renders the item smaller. When using a sub group, use the divider's title slot to set the id for aria-labelledby on the sub group: &lt; . action_list_section_divider &gt; &lt; :title id = &quot;title-01&quot; &gt; Section title &lt; / :title &gt; &lt; / . action_list_section_divider &gt; &lt; . action_list_item &gt; Item &lt; :sub_group aria - labelledby = &quot;title-01&quot; &gt; ... &lt; / :sub_group &gt; &lt; / . action_list_item &gt; Attributes aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . role ( :string ) - Adds attribute role to the outer element. Defaults to &quot;listbox&quot; . class ( :string ) - Additional classname. Defaults to nil . is_divided ( :boolean ) - Show dividers between items. Defaults to false . is_full_bleed ( :boolean ) - Removes the default padding. Defaults to false . is_multiple_select ( :boolean ) - Sets ARIA attribute and classes for multi select checkmarks. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Action list components. Reference Primer/CSS Action List Status Feature complete.","ref":"PrimerLive.Component.html#action_list/1","title":"PrimerLive.Component.action_list/1","type":"function"},{"doc":"Action list item. See action_list/1 . Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. checked_value ( :any ) - Checkbox checked_value . Defaults to nil . class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for section item elements. Any provided value will be appended to the default classname. Default map: %{ action_list_item : &quot;&quot; , # Action list item element (li) content : &quot;&quot; , # Content wrapper (span, a or button) label : &quot;&quot; , # Label container (span) description : &quot;&quot; , # Description container (span) description_container : &quot;&quot; , # Container around label and description (span) leading_visual : &quot;&quot; , # Leading visual container (span) trailing_visual : &quot;&quot; , # Trailing visual container (span) sub_group : &quot;&quot; , # Nested action_list } Defaults to %{content: nil, description: nil, description_container: nil, label: nil, leading_visual: nil, section_divider: nil, sub_group: nil, trailing_visual: nil} . is_selected ( :boolean ) - Shows the selected state. Link items show an active border at the left and a gray highlighted background Single select items show a check icon Multiple select items show a selected checkbox icon Defaults to false . is_selected_link_marker ( :boolean ) - When using is_single_select or is_multiple_select : creates a selected state similar for selected link items (border and background). Defaults to false . is_inline_description ( :boolean ) - Renders the description inline, on the same line as the label. Defaults to false . is_height_medium ( :boolean ) - Sets the row height to at least 40px. The default row height is 32px (on touch devices this is 48px). Defaults to false . is_height_large ( :boolean ) - Sets the row height to at least 48px. The default row height is 32px (on touch devices this is 48px as well). Defaults to false . is_single_select ( :boolean ) - Creates a radio button group, visualized as checkmark icons, and sets ARIA attributes. The icons can be replaced with the leading_visual slot. Defaults to false . is_multiple_select ( :boolean ) - Creates a checkbox group, using smaller sized checkboxes, and sets ARIA attributes. The icons can be replaced with the leading_visual slot. Defaults to false . is_checkmark_icon ( :boolean ) - When using is_multiple_select . Visualizes the checkboxes as checkmark icons. Defaults to false . is_button ( :boolean ) - Renders the content element with a button tag. Defaults to false . is_collapsible ( :boolean ) - Inserts a collapse icon as trailing visual (override the visual by using trailing_visual slot). Use with is_expanded and sets ARIA attributes. Uses a button element instead of span . When using slot sub_group , a false value of is_expanded will hide the sub group items. Defaults to false . is_expanded ( :boolean ) - Use with is_collapsible . Sets the state of the collapsible by setting ARIA attributes. When using slot sub_group , a false value of is_expanded will hide the sub group items; a true value will show the items and make the current item bold. Defaults to false . is_danger ( :boolean ) - Adds a &quot;danger&quot; style to show that the item is descrucive. Defaults to false . is_disabled ( :boolean ) - Shows the item is disabled. Defaults to false . is_truncated ( :boolean ) - Shortens the item label with ellipsis. Defaults to false . is_sub_item ( :boolean ) - For items within a sub_group . Renders the item smaller. Defaults to false . leading_visual_width ( :any ) - Use with the item that contains slots sub_group and leading_visual . Indents the items within the sub group to match the leading visual. Supported sizes: 16, 20, 24. Global attributes are accepted. Slots inner_block (required) - Label. link - Creates a link. Pass attribute href , navigate or patch . Accepts attributes: href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the link element. description - Description. leading_visual - Container for a leading visual. Commonly a octicon/1 component is used. The container's width is determined by the content. Use the same size icons and graphics for consistency. A common icon size is 16px. trailing_visual - Container for a trailing visual. Commonly a octicon/1 component is used, but a textual &quot;visual&quot; is also possible. sub_group - Creates a nested action_list/1 . Pass action_list_items as children. Use is_sub_item for child items to render them smaller. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the action list element.","ref":"PrimerLive.Component.html#action_list_item/1","title":"PrimerLive.Component.action_list_item/1","type":"function"},{"doc":"Action list section divider for separating groups of content. See action_list/1 . Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for section divider elements. Any provided value will be appended to the default classname. Default map: %{ section_divider : &quot;&quot; , # Section divider element (li) title : &quot;&quot; , # Title container (h3) description : &quot;&quot; , # Description container (span) } Defaults to %{description: nil, section_divider: nil, title: nil} . is_filled ( :boolean ) - Creates a higher horizontal line. When used with the title slot, the title is placed inside the line. Defaults to false . Global attributes are accepted. Slots title - Title separator. The input text is wrapped in a &lt;h3&gt; element. Omit to create a horizontal line only. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the action list element. description - Optional extra text. Requires title slot. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the action list element.","ref":"PrimerLive.Component.html#action_list_section_divider/1","title":"PrimerLive.Component.action_list_section_divider/1","type":"function"},{"doc":"Generates an action menu. The action menu functions similarly to a select_menu/1 , but with an action_list/1 as content. &lt; . action_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; . action_list &gt; ... &lt; / . action_list &gt; &lt; / . action_menu &gt; Examples Create a multiple select menu: &lt; . action_menu is_dropdown_caret &gt; &lt; :toggle &gt; Select &lt; . counter &gt; 2 &lt; / . counter &gt; &lt; / :toggle &gt; &lt; . action_list &gt; &lt; . action_list_item is_multiple_select is_selected &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_multiple_select is_selected &gt; Option &lt; / . action_list_item &gt; &lt; . action_list_item is_multiple_select &gt; Option &lt; / . action_list_item &gt; &lt; / . action_list &gt; &lt; / . action_menu &gt; See for more examples: Action list examples Select menu examples Attributes is_dropdown_caret ( :boolean ) - Adds a dropdown caret to the button. Defaults to false . is_right_aligned ( :boolean ) - Aligns the menu to the right. Defaults to false . class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for action menu elements. Any provided value will be appended to the default classname, except for toggle that will override the default class &quot;btn&quot;. Default map: %{ action_menu : &quot;&quot; , # Action menu container (details element). caret : &quot;&quot; , # Dropdown caret element. menu_container : &quot;&quot; , # Menu container (called &quot;modal&quot; at PrimerCSS). menu_list : &quot;&quot; , # Menu list container. menu : &quot;&quot; , # Menu element toggle : &quot;&quot; , # Toggle element. Any value will override the # default class &quot;btn&quot;. } Defaults to %{action_menu: nil, caret: nil, menu: nil, menu_container: nil, menu_list: nil, toggle: nil} . is_backdrop ( :boolean ) - Generates a light backdrop background color. Defaults to false . is_dark_backdrop ( :boolean ) - Generates a darker backdrop background color. Defaults to false . is_medium_backdrop ( :boolean ) - Generates a medium backdrop background color. Defaults to false . is_light_backdrop ( :boolean ) - Generates a lighter backdrop background color (default). Defaults to false . is_fast ( :boolean ) - Generates fast fade transitions for backdrop and content. Defaults to true . menu_theme ( :map ) - Sets the theme of the menu, including the dropdown shadow, but excluding the toggle button. This is useful when the button resides in a part with a different theme, such as a dark header. Pass a a map with all theme state keys. See theme/1 . Example: &lt; . header &gt; &lt; . action_menu menu_theme = { @theme_state } &gt; &lt; :toggle &gt; &lt; . octicon name = &quot;sun-16&quot; / &gt; &lt; / :toggle &gt; &lt; . theme_menu_options default_theme_state = { @default_theme_state } theme_state = { @theme_state } / &gt; &lt; / . action_menu &gt; &lt; . / header &gt; Defaults to nil . Global attributes are accepted. Slots toggle (required) - Generates a toggle element (default with button appearance) using the slot content as label.Any custom class will override the default class &quot;btn&quot;.Accepts attributes: rest ( :any ) - Additional HTML attributes added to the item element. inner_block - Slot to place the action_list/1 component. Reference Primer/CSS Select menu Primer/CSS Action List Status Feature complete.","ref":"PrimerLive.Component.html#action_menu/1","title":"PrimerLive.Component.action_menu/1","type":"function"},{"doc":"Generates an alert message. &lt; . alert &gt; Flash message goes here . &lt; / . alert &gt; Examples Add color to the alert by using attribute state . Possible states: &quot;default&quot; - light blue &quot;info&quot; - same as default &quot;success&quot; - light green &quot;warning&quot; - light yellow &quot;error&quot; - pink Add a success color to the alert: &lt; . alert state = &quot;success&quot; &gt; You &#39; re done! &lt; / . alert &gt; Multiline message: &lt; . alert state = &quot;success&quot; &gt; &lt; p &gt; You &#39; re done! &lt; / p &gt; &lt; p &gt; You may close this message &lt; / p &gt; &lt; / . alert &gt; To add an extra bottom margin to a stack of alerts, wrap the alerts in alert_messages/1 . Attributes class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for the alert element and alert states. Any provided value will be appended to the default classname. Default map: %{ alert : &quot;&quot; , # Outer container state_default : &quot;&quot; , # Alert color modifier state_info : &quot;&quot; , # Alert color modifier state_success : &quot;&quot; , # Alert color modifier state_warning : &quot;&quot; , # Alert color modifier state_error : &quot;&quot; , # Alert color modifier } Defaults to %{alert: nil, state_default: nil, state_error: nil, state_info: nil, state_success: nil, state_warning: nil} . state ( :string ) - Color mapping: &quot;default&quot; - light blue &quot;info&quot; - same as default &quot;success&quot; - light green &quot;warning&quot; - light yellow &quot;error&quot; - pink Must be one of &quot;default&quot; , &quot;info&quot; , &quot;success&quot; , &quot;warning&quot; , or &quot;error&quot; . is_full ( :boolean ) - Renders the alert full width, with border and border radius removed. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Alert content. Reference Primer/CSS Alerts Status To do: Flash (page) banner","ref":"PrimerLive.Component.html#alert/1","title":"PrimerLive.Component.alert/1","type":"function"},{"doc":"Wrapper to render a vertical stack of alert/1 messages with spacing in between. &lt; . alert_messages &gt; &lt; . alert is_success &gt; Message 1 &lt; / . alert &gt; &lt; . alert class = &quot;mt-4&quot; &gt; Message 2 &lt; / . alert &gt; &lt; / . alert_messages &gt; Rest of content Attributes class ( :string ) - Additional classname. Global attributes are accepted. Slots inner_block (required) - Alert messages content. Reference Primer/CSS Alerts Status Feature complete.","ref":"PrimerLive.Component.html#alert_messages/1","title":"PrimerLive.Component.alert_messages/1","type":"function"},{"doc":"Adds animated ellipsis to indicate progress. &lt; . animated_ellipsis / &gt; Examples Inside a header: &lt; h2 &gt; Loading &lt; . animated_ellipsis / &gt; &lt; / h2 &gt; Inside a label: &lt; . label &gt; Loading &lt; . animated_ellipsis / &gt; &lt; / . label &gt; Inside a button: &lt; . button is_disabled &gt; Loading &lt; . animated_ellipsis / &gt; &lt; / . label &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . Global attributes are accepted. Reference Primer/CSS Loaders Status Feature complete.","ref":"PrimerLive.Component.html#animated_ellipsis/1","title":"PrimerLive.Component.animated_ellipsis/1","type":"function"},{"doc":"Generates a consistent link-like appearance of actual links and spans inside links. The component name deviates from the PrimerCSS name Link to prevent a naming conflict with Phoenix.Component.link/1 . Some text with a &lt; . as_link &gt; link &lt; / . as_link &gt; Examples links are created with Phoenix.Component.link/1 . Link examples: &lt; . as_link href = &quot;/home&quot; &gt; label &lt; / . as_link &gt; &lt; . as_link navigate = &quot;/home&quot; &gt; label &lt; / . as_link &gt; &lt; . as_link patch = &quot;/home&quot; &gt; label &lt; / . as_link &gt; Turn a link blue only on hover: &lt; . as_link href = &quot;/home&quot; is_primary &gt; link &lt; / . as_link &gt; Give it a muted gray color: &lt; . as_link href = &quot;/home&quot; is_secondary &gt; link &lt; / . as_link &gt; Turn a link blue only on hover: &lt; . as_link href = &quot;/home&quot; is_primary &gt; link &lt; / . as_link &gt; Rmove the underline: &lt; . as_link href = &quot;/home&quot; is_no_underline &gt; link &lt; / . as_link &gt; Use is_on_hover to make any text color used with links to turn blue on hover. This is useful when you want only part of a link to turn blue on hover. We are using a nested as_link for this: &lt; p &gt; &lt; . as_link href = &quot;#url&quot; is_muted is_no_underline &gt; A link with a partial &lt; . as_link is_on_hover &gt; hover link &lt; / . as_link &gt; &lt; / . as_link &gt; &lt; / p &gt; Combine with color utility classes &lt; p &gt; &lt; . as_link href = &quot;#url&quot; is_primary class = &quot;text-bold&quot; &gt; &lt; . octicon name = &quot;flame-16&quot; width = &quot;12&quot; class = &quot;color-fg-danger&quot; / &gt; Hot &lt; span class = &quot;color-fg-muted&quot; &gt; potato &lt; / span &gt; &lt; / . as_link &gt; &lt; / p &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . is_primary ( :boolean ) - Turns the link color to blue only on hover. Defaults to false . is_secondary ( :boolean ) - Turns the link color to blue only on hover, using a darker color. Defaults to false . is_muted ( :boolean ) - Turns the link to muted gray, also on hover. Defaults to false . is_no_underline ( :boolean ) - Removes the underline on hover. Defaults to false . is_on_hover ( :boolean ) - Makes any text color used with links to turn blue on hover. This is useful when you want only part of a link to turn blue on hover. Defaults to false . href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . Global attributes are accepted. Slots inner_block (required) - Link content. Reference Primer/CSS Links Status Feature complete.","ref":"PrimerLive.Component.html#as_link/1","title":"PrimerLive.Component.as_link/1","type":"function"},{"doc":"User profile image. A simple wrapper function that returns an img element, styled square and rounded. For correct rendering, the input image must be square. &lt; . avatar src = &quot;user.jpg&quot; / &gt; Examples Set the size (possible values: 1 - 8): &lt; . avatar size = &quot;1&quot; src = &quot;user.jpg&quot; / &gt; Or set the size using regular img tags: &lt; . avatar src = &quot;user.jpg&quot; width = &quot;20&quot; height = &quot;20&quot; / &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . size ( :integer ) - Avatar size. Values translate to sizes: 1: 16px 2: 20px 3: 24px (default) 4: 28px 5: 32px 6: 40px 7: 48px 8: 64px Defaults to 3 . Global attributes are accepted. Reference Primer/CSS Avatars Status Feature complete.","ref":"PrimerLive.Component.html#avatar/1","title":"PrimerLive.Component.avatar/1","type":"function"},{"doc":"Generates fallback content if the actual content does not yet exist or if the user needs to perform an action. &lt; . blankslate &gt; &lt; :heading &gt; This is a blank slate &lt; / :heading &gt; &lt; p &gt; Use it to provide information when no dynamic content exists . &lt; / p &gt; &lt; / . blankslate &gt; Blankslate is created with slots that are applied in this order: octicon or img heading inner_block action (multiple) Examples With an octicon/1 : &lt; . blankslate &gt; &lt; :octicon name = &quot;rocket-24&quot; / &gt; ... &lt; / . blankslate &gt; With an image: &lt; . blankslate &gt; &lt; :img src = &quot;https://ghicons.github.com/assets/images/blue/png/Pull%20request.png&quot; alt = &quot;&quot; / &gt; ... &lt; / . blankslate &gt; With an action: &lt; . blankslate &gt; &lt; :action &gt; &lt; . button is_primary &gt; New project &lt; / . button &gt; &lt; / :action &gt; ... &lt; / . blankslate &gt; Narrow layout: &lt; . blankslate is_narrow &gt; ... &lt; / . blankslate &gt; Large text: &lt; . blankslate is_large &gt; ... &lt; / . blankslate &gt; Combined slots, in a box/1 : &lt; . box &gt; &lt; . blankslate &gt; &lt; :heading &gt; This is a blank slate &lt; / :heading &gt; &lt; :img src = &quot;https://ghicons.github.com/assets/images/blue/png/Pull%20request.png&quot; alt = &quot;&quot; / &gt; &lt; :action &gt; &lt; . button is_primary &gt; New project &lt; / . button &gt; &lt; / :action &gt; &lt; :action &gt; &lt; . button is_link &gt; Learn more &lt; / . button &gt; &lt; / :action &gt; &lt; p &gt; Use it to provide information when no dynamic content exists . &lt; / p &gt; &lt; / . blankslate &gt; &lt; / . box &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for blankslate elements. Any provided value will be appended to the default classname. Default map: %{ blankslate : &quot;&quot; , # Blankslate wrapper octicon : &quot;&quot; # Icon element img : &quot;&quot; , # Image element heading : &quot;&quot; , # Heading element action : &quot;&quot; , # Action element } Defaults to %{action: nil, blankslate: nil, heading: nil, img: nil, octicon: nil} . is_narrow ( :boolean ) - Narrows the blankslate container to not occupy the entire available width. Defaults to false . is_large ( :boolean ) - Increases the size of the text in the blankslate. Defaults to false . is_spacious ( :boolean ) - Significantly increases the vertical padding. Defaults to false . Global attributes are accepted. Slots heading - Heading. Accepts attributes: tag ( :string ) - HTML tag used for the heading. Default: &quot;h3&quot;. rest ( :any ) - Attributes supplied to the heading. octicon - Adds a top icon with octicon/1 . Accepts attributes: rest ( :any ) - Attributes supplied to the octicon component. img - Adds a top image with an img tag. Accepts attributes: rest ( :any ) - HTML attributes supplied to the img element. action - Adds a wrapper for a button or link. Accepts attributes: rest ( :any ) - HTML attributes supplied to the action wrapper element. inner_block - Regular content. Reference Primer/CSS Blankslate Status Feature complete.","ref":"PrimerLive.Component.html#blankslate/1","title":"PrimerLive.Component.blankslate/1","type":"function"},{"doc":"Generates a content container. A box is a container with rounded corners, a white background, and a light gray border. By default, there are no other styles, such as padding; however, these can be introduced with utility classes as needed. &lt; . box &gt; Content &lt; / . box &gt; Slots allow for the creation of alternative styles and layouts. &lt; . box &gt; &lt; :header &gt; Header &lt; / :header &gt; &lt; :body &gt; Body &lt; / :body &gt; &lt; :row &gt; Row &lt; / :row &gt; &lt; :footer &gt; Footer &lt; / :footer &gt; &lt; / . box &gt; Examples Row themes: &lt; . box &gt; &lt; :row is_gray &gt; Row &lt; / :row &gt; &lt; :row is_hover_gray &gt; Row &lt; / :row &gt; &lt; :row is_yellow &gt; Row &lt; / :row &gt; &lt; :row is_hover_blue &gt; Row &lt; / :row &gt; &lt; :row is_blue &gt; Row &lt; / :row &gt; &lt; / . box &gt; Box theme - &quot;danger box&quot;: &lt; . box is_danger &gt; &lt; :row &gt; Row &lt; / :row &gt; &lt; :row &gt; Row &lt; / :row &gt; &lt; / . box &gt; Header theme - blue header: &lt; . box &gt; &lt; :header is_blue &gt; Blue header &lt; / :header &gt; &lt; / . box &gt; Render a row for each search result: &lt; . box &gt; &lt; :row :for = { result &lt;- @results } &gt; &lt; % = result % &gt; &lt; / :row &gt; &lt; / . box &gt; Conditionally show an alert: &lt; . box &gt; &lt; . alert :if = { @show_alert } &gt; Alert message &lt; / . alert &gt; &lt; :body &gt; Body &lt; / :body &gt; &lt; / . box &gt; Header title. Slot header can be omitted: &lt; . box &gt; &lt; :header_title &gt; Title &lt; / :header_title &gt; Content &lt; / . box &gt; Header with a button, using both header and header_title slots. The title will be inserted as first header element: &lt; . box &gt; &lt; :header class = &quot;d-flex flex-items-center&quot; &gt; &lt; . button is_primary is_smmall &gt; Button &lt; / . button &gt; &lt; / :header &gt; &lt; :header_title class = &quot;flex-auto&quot; &gt; Title &lt; / :header_title &gt; &lt; :body &gt; Rest &lt; / :body &gt; &lt; / . box &gt; Header with icon button: &lt; . box &gt; &lt; :header class = &quot;d-flex flex-justify-between flex-items-start&quot; &gt; &lt; . button is_close_button aria - label = &quot;Close&quot; class = &quot;flex-shrink-0 pl-4&quot; &gt; &lt; . octicon name = &quot;x-16&quot; / &gt; &lt; / . button &gt; &lt; / :header &gt; &lt; :header_title &gt; A very long title that wraps onto multiple lines without overlapping or wrapping underneath the icon to it &#39; s right &lt; / :header_title &gt; &lt; :body &gt; Content &lt; / :body &gt; &lt; / . box &gt; Links can be placed inside rows. Use :let to get access to the classes.link class. With Phoenix.Component.link/1 : &lt; . box &gt; &lt; :row :let = { classes } &gt; &lt; . link href = &quot;/&quot; class = { classes . link } &gt; Home &lt; / . link &gt; &lt; / :row &gt; &lt; / . box &gt; To make the entire row a link, pass attribute href , navigate or patch . Tweak the link behaviour with row attrs is_hover_gray , is_hover_blue and/or Primer CSS modifier class &quot;no-underline&quot;. Link examples: &lt; :row href = &quot;#url&quot; &gt; href link &lt; / :row &gt; &lt; :row navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :row &gt; &lt; :row patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :row &gt; &lt; :row href = &quot;#url&quot; class = &quot;no-underline&quot; is_hover_gray &gt; Link , no underline , hover gray &lt; / :row &gt; Box can be used inside dialogs. To make the box content scrollable within the confined space of the dialog, use is_scrollable . This will make all inner content ( inner_block , body and rows ) scrollable between header and footer. To limit the height of the box, either: Use class &quot;Box--scrollable&quot; to limit the height to 324px Add style &quot;max-height&quot; &lt; . box is_scrollable class = &quot;Box--scrollable&quot; &gt; &lt; :header &gt; Fixed header &lt; / :header &gt; &lt; :body &gt; Scrollable body &lt; / :body &gt; &lt; :row &gt; Scrollable row &lt; / :row &gt; &lt; :row &gt; Scrollable row &lt; / :row &gt; ... &lt; :footer &gt; Fixed footer &lt; / :footer &gt; &lt; / . box &gt; &lt; . box is_scrollable style = &quot;max-height: 80vh&quot; &gt; &lt; :header &gt; Fixed header &lt; / :header &gt; &lt; :body &gt; Scrollable body &lt; / :body &gt; &lt; :row &gt; Scrollable row &lt; / :row &gt; &lt; :row &gt; Scrollable row &lt; / :row &gt; ... &lt; :footer &gt; Fixed footer &lt; / :footer &gt; &lt; / . box &gt; Attributes class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for layout elements. Any provided value will be appended to the default classname. Default map: %{ box : &quot;&quot; , # Box element header : &quot;&quot; , # Box header row element row : &quot;&quot; , # Box content row element body : &quot;&quot; , # Content element footer : &quot;&quot; , # Footer row element header_title : &quot;&quot; , # Title element within a header row link : &quot;&quot; , # Class for links } Defaults to %{body: nil, box: nil, footer: nil, header: nil, header_title: nil, link: nil, row: nil} . is_blue ( :boolean ) - Generates a blue box theme. Defaults to false . is_danger ( :boolean ) - Generates a danger color box theme. Only works with slots row and body . Defaults to false . is_border_dashed ( :boolean ) - Applies a dashed border to the box. Defaults to false . is_condensed ( :boolean ) - Condenses line-height and reduces the padding on the Y axis. Defaults to false . is_spacious ( :boolean ) - Increases padding and increases the title font size. Defaults to false . is_scrollable ( :boolean ) - Makes inner content (consistent of inner_block , body and rows ) scrollable in a box with maximum height. Defaults to false . Global attributes are accepted. Slots header - Generates a header row element. Accepts attributes: class ( :string ) - Additional classname. is_blue ( :boolean ) - Change the header border and background to blue. header_title - Generates a title within the header. If no header slot is passed, the header title will be wrapped inside a header element. Accepts attributes: class ( :string ) - Additional classname. row - Generates a content row element. To create a link element, pass attribute href , navigate or patch . Accepts attributes: class ( :string ) - Additional classname. is_blue ( :boolean ) - Blue row theme. is_gray ( :boolean ) - Gray row theme. is_yellow ( :boolean ) - Yellow row theme. is_hover_blue ( :boolean ) - Changes to blue row theme on hover. is_hover_gray ( :boolean ) - Changes to gray row theme on hover. is_focus_blue ( :boolean ) - Changes to blue row theme on focus. is_focus_gray ( :boolean ) - Changes to gray row theme on focus. is_navigation_focus ( :boolean ) - Combine with a theme color to highlight the row when using keyboard commands. is_unread ( :boolean ) - Apply a blue vertical line highlight for indicating a row contains unread items. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the row element. body - Generates a body element. Accepts attributes: class ( :string ) - Additional classname. footer - Generates a footer row element. Accepts attributes: class ( :string ) - Additional classname. inner_block (required) - Unstructured content. Lets &lt; :item :let = { classes } / &gt; Yields a classes map, containing the merged values of default classnames, plus any value supplied to the classes component attribute. &lt; . box classes = { %{ link : &quot;link-x&quot; } } &gt; &lt; :row :let = { classes } &gt; &lt; . link href = &quot;/&quot; class = { [ &quot;my-link&quot; , classes . link ] } &gt; Home &lt; / . link &gt; &lt; / :row &gt; &lt; / . box &gt; Results in: &lt; div class = &quot;Box&quot; &gt; &lt; div class = &quot;Box-row&quot; &gt; &lt; a href = &quot;/&quot; class = &quot;my-link Box-row-link link-x&quot; &gt; Home &lt; / a &gt; &lt; / div &gt; &lt; / div &gt; Reference Primer/CSS Box Status Feature complete.","ref":"PrimerLive.Component.html#box/1","title":"PrimerLive.Component.box/1","type":"function"},{"doc":"Formats a branch name. &lt; . branch_name &gt; development &lt; / . branch_name &gt; Examples A branch name may be a link. Links are created with Phoenix.Component.link/1 , passing all other attributes to the link. Link examples: &lt; . branch_name href = &quot;#url&quot; &gt; some - name &lt; / . branch_name &gt; &lt; . branch_name navigate = { Routes . page_path ( @socket , :index ) } &gt; some - name &lt; / . branch_name &gt; &lt; . branch_name patch = { Routes . page_path ( @socket , :index , :details ) } &gt; some - name &lt; / . branch_name &gt; Add an icon before the branch name: &lt; . branch_name &gt; &lt; . octicon name = &quot;git-branch-16&quot; / &gt; some - name &lt; / . branch_name &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . Global attributes are accepted. Slots inner_block (required) - The branch name text and optionally an icon. Reference Primer/CSS Branch name Status Feature complete.","ref":"PrimerLive.Component.html#branch_name/1","title":"PrimerLive.Component.branch_name/1","type":"function"},{"doc":"Breadcrumb navigation to navigate a hierarchy of pages. All items are rendered as links. The last link will show a selected state. &lt; . breadcrumb &gt; &lt; :item href = &quot;/home&quot; &gt; Home &lt; / :item &gt; &lt; :item href = &quot;/account&quot; &gt; Account &lt; / :item &gt; &lt; :item href = &quot;/account/history&quot; &gt; History &lt; / :item &gt; &lt; / . breadcrumb &gt; Examples Links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for breadcrumb elements. Any provided value will be appended to the default classname. Default map: %{ breadcrumb : &quot;&quot; , # Breadcrumb container item : &quot;&quot; , # Breadcrumb item (li element) selected_item : &quot;&quot; , # Selected breadcrumb item (li element) link : &quot;&quot; , # Link } Defaults to %{breadcrumb: nil, item: nil, link: nil, selected_item: nil} . Global attributes are accepted. Slots item (required) - Breadcrumb item content. To create a link element, pass attribute href , navigate or patch . Accepts attributes: href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. Reference Primer/CSS Breadcrumbs Status Feature complete.","ref":"PrimerLive.Component.html#breadcrumb/1","title":"PrimerLive.Component.breadcrumb/1","type":"function"},{"doc":"Generates a button. &lt; . button &gt; Click me &lt; / . button &gt; Examples Optionally create an anchor link rendered as a button. Anchor links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; . button href = &quot;#url&quot; &gt; href link &lt; / . button &gt; &lt; . button navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / . button &gt; &lt; . button patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / . button &gt; Primary button: &lt; . button is_primary &gt; Sign in &lt; / . button &gt; Small button: &lt; . button is_small &gt; Edit &lt; / . button &gt; Selected button: &lt; . button is_selected &gt; Unread &lt; / . button &gt; With a dropdown caret: &lt; . button is_dropdown_caret &gt; Menu &lt; / . button &gt; Button that contains an icon next to the button label: &lt; . button is_primary &gt; &lt; . octicon name = &quot;download-16&quot; / &gt; &lt; span &gt; Clone &lt; / span &gt; &lt; / . button &gt; Icon button (a button with an icon, similar to Primer React's IconButton): &lt; . button is_icon_button aria - label = &quot;Desktop&quot; &gt; &lt; . octicon name = &quot;device-desktop-16&quot; / &gt; &lt; / . button &gt; Icon as button (reduced padding): &lt; . button is_icon_only aria - label = &quot;Desktop&quot; &gt; &lt; . octicon name = &quot;device-desktop-16&quot; / &gt; &lt; / . button &gt; Use button_group/1 to create a group of buttons: &lt; . button_group &gt; &lt; . button_group_item &gt; Button 1 &lt; / . button_group_item &gt; &lt; . button_group_item &gt; Button 2 &lt; / . button_group_item &gt; &lt; . button_group_item &gt; Button 3 &lt; / . button_group_item &gt; &lt; / . button_group &gt; Attributes class ( :string ) - Additional classname. is_full_width ( :boolean ) - Generates a full-width button. Defaults to false . is_close_button ( :boolean ) - Use when enclosing icon &quot;x-16&quot;. This setting removes the default padding. Defaults to false . is_dropdown_caret ( :boolean ) - Adds a dropdown caret icon. Defaults to false . is_danger ( :boolean ) - Generates a danger button (red label, turns the button red on hover). Defaults to false . is_disabled ( :boolean ) - Generates a disabled button. Defaults to false . is_icon_button ( :boolean ) - Generates an icon button without a label (similar to Primer React's IconButton). Add is_danger to create a danger icon (turns the icon red on hover). Defaults to false . is_icon_only ( :boolean ) - Generates an icon that functions as a button. Add is_danger to create a danger icon (turns the icon red on hover). Defaults to false . is_invisible ( :boolean ) - Create a button that looks like a link, maintaining the paddings of a regular button. Defaults to false . is_large ( :boolean ) - Generates a large button. Defaults to false . is_link ( :boolean ) - Create a button that looks like a link. Defaults to false . is_outline ( :boolean ) - Generates an outline button. Defaults to false . is_primary ( :boolean ) - Generates a primary colored button. Defaults to false . is_selected ( :boolean ) - Generates a selected button. Defaults to false . is_small ( :boolean ) - Generates a small button. Defaults to false . is_submit ( :boolean ) - Generates a button with type=&quot;submit&quot;. Defaults to false . href ( :any ) - Creates an anchor link using Phoenix.Component.link/1 , passing all other attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . Global attributes are accepted. Slots inner_block (required) - Button content. Reference Primer/CSS Buttons Status Feature complete.","ref":"PrimerLive.Component.html#button/1","title":"PrimerLive.Component.button/1","type":"function"},{"doc":"Generates a group of buttons. &lt; . button_group &gt; &lt; :button &gt; Button 1 &lt; / :button &gt; &lt; :button &gt; Button 2 &lt; / :button &gt; &lt; :button &gt; Button 3 &lt; / :button &gt; &lt; / . button_group &gt; Examples Use button slots while passing button attributes to create the button row: &lt; . button_group &gt; &lt; :button &gt; Button 1 &lt; / :button &gt; &lt; :button is_selected &gt; Button 2 &lt; / :button &gt; &lt; :button is_danger &gt; Button 3 &lt; / :button &gt; &lt; :button class = &quot;my-button&quot; &gt; Button 4 &lt; / :button &gt; &lt; / . button_group &gt; Attributes class ( :string ) - Additional classname. Global attributes are accepted. Slots button (required) - Button. Use button/1 attributes to configure the button appearance and behaviour. Reference Primer/CSS Button groups Status Feature complete.","ref":"PrimerLive.Component.html#button_group/1","title":"PrimerLive.Component.button_group/1","type":"function"},{"doc":"Generates a checkbox. Wrapper around Phoenix.HTML.Form.checkbox/3 . &lt; . checkbox name = &quot;available_for_hire&quot; / &gt; Examples Set the checked state: &lt; . checkbox name = &quot;available_for_hire&quot; checked / &gt; Using the checkbox with form data. This will automatically create the checkbox label: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . checkbox form = { f } field = { :available_for_hire } / &gt; &lt; / . form &gt; Pass a custom checkbox label with the label slot: &lt; . checkbox form = { :user } field = { :available_for_hire } &gt; &lt; :label &gt; Some label &lt; / :label &gt; &lt; / . checkbox &gt; Add emphasis to the label: &lt; . checkbox name = &quot;available_for_hire&quot; is_emphasised_label / &gt; Add a hint below the label: &lt; . checkbox name = &quot;available_for_hire&quot; &gt; &lt; :label &gt; Some label &lt; / :label &gt; &lt; :hint &gt; Add your &lt; strong &gt; resume &lt; / strong &gt; below &lt; / :hint &gt; &lt; / . checkbox &gt; Reveal extra details when the checkbox is checked: &lt; . checkbox name = &quot;available_for_hire&quot; &gt; &lt; :label &gt; Some label &lt; / :label &gt; &lt; :disclosure &gt; &lt; span class = &quot;d-block mb-1&quot; &gt; Available hours per week &lt; / span &gt; &lt; . text_input is_contrast size = &quot;3&quot; / &gt; &lt; span class = &quot;text-small color-fg-muted pl-2&quot; &gt; hours per week &lt; / span &gt; &lt; / :disclosure &gt; &lt; / . checkbox &gt; Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. is_multiple ( :boolean ) - When creating a list of checkboxes. Appends [] to the input name so that a list of values is passed to the form events. Defaults to false . is_emphasised_label ( :boolean ) - Adds emphasis to the label. Defaults to false . is_omit_label ( :boolean ) - Omits any label. Defaults to false . class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for checkbox elements. Any provided value will be appended to the default classname. Default map: %{ container : &quot;&quot; , # Checkbox container label_container : &quot;&quot; , # Input label container label : &quot;&quot; , # Input label input : &quot;&quot; , # Checkbox input element hint : &quot;&quot; , # Hint message container disclosure : &quot;&quot; # Disclosure container (inline) } Defaults to %{container: nil, disclosure: nil, hint: nil, input: nil, label: nil, label_container: nil} . Global attributes are accepted. Slots label - Custom checkbox label. Overides the derived label when using a form and field . Accepts attributes: rest ( :any ) - Additional HTML attributes added to the label element. hint - Adds text below the checkbox label. Enabled when a label is displayed. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the hint element. disclosure - Extra label content to be revealed when the checkbox is checked. Enabled when a label is displayed.Note that the label element can only contain inline child elements.Accepts attributes: rest ( :any ) - Additional HTML attributes added to the disclosure wrapper element. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#checkbox/1","title":"PrimerLive.Component.checkbox/1","type":"function"},{"doc":"Generates a badge-like icon or logo. &lt; . circle_badge &gt; &lt; :octicon name = &quot;alert-16&quot; / &gt; &lt; / . circle_badge &gt; Examples Use slot octicon to create an octicon/1 icon &lt; . circle_badge &gt; &lt; :octicon name = &quot;alert-16&quot; / &gt; &lt; / . circle_badge &gt; Use slot img to create an image icon &lt; . circle_badge &gt; &lt; :img src = &quot;https://github.com/travis-ci.png&quot; / &gt; &lt; / . circle_badge &gt; Create a large badge (size &quot;medium&quot; or &quot;large&quot;): &lt; . circle_badge size = &quot;medium&quot; &gt; &lt; :octicon name = &quot;alert-24&quot; / &gt; &lt; / . circle_badge &gt; Badges are by default rendered as div elements. To create link elements, pass attribute href , navigate or patch . Link examples: &lt; . circle_badge href = &quot;#url&quot; &gt; ... &lt; / . circle_badge &gt; &lt; . circle_badge navigate = { Routes . page_path ( @socket , :index ) } &gt; ... &lt; / . circle_badge &gt; &lt; . circle_badge patch = { Routes . page_path ( @socket , :index , :details ) } &gt; ... &lt; / . circle_badge &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . size ( :string ) - Badge size: &quot;small&quot;, &quot;medium&quot; or &quot;large&quot;. Sizes: small: 56px (default) medium: 96px large: 128px Defaults to &quot;small&quot; . href ( :any ) - Link attribute. If used, the badge will be created with Phoenix.Component.link/1 , passing all other attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . Global attributes are accepted. Slots octicon - Generates a badge icon with octicon/1 . Accepts attributes: rest ( :any ) - Attributes supplied to the octicon component. img - Generates a badge icon with an img tag. Accepts attributes: rest ( :any ) - HTML attributes supplied to the img element. Reference Primer/CSS Avatars Status Feature complete.","ref":"PrimerLive.Component.html#circle_badge/1","title":"PrimerLive.Component.circle_badge/1","type":"function"},{"doc":"Adds a count to navigational elements and buttons. &lt; . counter &gt; 12 &lt; / . counter &gt; Examples Apply primary state: &lt; . counter is_primary &gt; 12 &lt; / . counter &gt; With an icon: &lt; . counter &gt; &lt; . octicon name = &quot;comment-16&quot; / &gt; 1.5 K &lt; / . counter &gt; Add an emoji: &lt; . counter &gt; 👍 2 &lt; / . counter &gt; Attributes class ( :string ) - Additional classname. is_primary ( :boolean ) - Primary color. Defaults to false . is_secondary ( :boolean ) - Secondary color. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Label content. Reference Primer/CSS Labels Status Feature complete.","ref":"PrimerLive.Component.html#counter/1","title":"PrimerLive.Component.counter/1","type":"function"},{"doc":"Dialog, often called Modal. A dialog is created with box/1 slots. &lt; . dialog &gt; &lt; :header_title &gt; Title &lt; / :header_title &gt; &lt; :body &gt; Message in a dialog &lt; / :body &gt; &lt; / . dialog &gt; Showing and hiding is done with JS function Prompt from dialogic-js , included in primer-js (see Installation). Function Prompt.show requires a selector. When placed inside the dialog component, the selector can be replaced with this : &lt; . dialog id = &quot;my-dialog&quot; &gt; &lt; :body &gt; Message in a dialog &lt; . button onclick = &quot;Prompt.hide(this)&quot; &gt; Close &lt; / . button &gt; &lt; / :body &gt; &lt; / . dialog &gt; &lt; . button onclick = &quot;Prompt.show(&#39;#my-dialog&#39;)&quot; &gt; Open dialog &lt; / . button &gt; Examples Add a backdrop. Optionally add is_light_backdrop or is_dark_backdrop : &lt; . dialog is_backdrop is_dark_backdrop &gt; ... &lt; / . dialog &gt; Create a modal dialog; clicking the backdrop (if used) or outside of the dialog will not close the dialog: &lt; . dialog is_modal &gt; ... &lt; / . dialog &gt; Close the dialog with the Escape key: &lt; . dialog is_escapable &gt; ... &lt; / . dialog &gt; Create faster fade in and out: &lt; . dialog is_fast &gt; ... &lt; / . dialog &gt; A narrow dialog: &lt; . dialog is_narrow &gt; ... &lt; / . dialog &gt; A wide dialog: &lt; . dialog is_wide &gt; ... &lt; / . dialog &gt; Focus the first element after opening the dialog. Pass a selector to match the element. &lt; . dialog focus_first = &quot;#login_first_name&quot; &gt; ... &lt; / . dialog &gt; or &lt; . dialog focus_first = &quot;[name=login \\[ first_name \\] ]&quot; &gt; ... &lt; / . dialog &gt; Long content will automatically show a scrollbar. To change the maxium height of the dialog, use a CSS value. Use unit vh or % . &lt; . dialog max_height = &quot;50vh&quot; &gt; ... &lt; / . dialog &gt; Add a header title and a footer. box slot header slot is automatically added when header_title is used. &lt; . dialog &gt; &lt; :header_title &gt; Title &lt; / :header_title &gt; ... &lt; :footer &gt; Footer &lt; / :footer &gt; &lt; / . dialog &gt; A dialog with rows: &lt; . dialog &gt; &lt; :header_title &gt; Title &lt; / :header_title &gt; &lt; :row &gt; Row 1 &lt; / :row &gt; &lt; :row &gt; Row 2 &lt; / :row &gt; &lt; :row &gt; Row 3 &lt; / :row &gt; &lt; :row &gt; Row 4 &lt; / :row &gt; &lt; :footer &gt; Footer &lt; / :footer &gt; &lt; / . dialog &gt; Dialog are wrapped inside a Phoenix.Compoennt.focus_wrap/1 so that navigating with Tab won't leave the dialog. &lt; . dialog is_backdrop is_modal &gt; &lt; :header_title &gt; Title &lt; / :header_title &gt; &lt; :body &gt; &lt; . text_input form = { :user } field = { :first_name } is_group / &gt; &lt; . text_input form = { :user } field = { :last_name } is_group / &gt; &lt; / :body &gt; &lt; / . dialog &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for dialog elements. Any provided value will be appended to the default classname. Default map: %{ # Dialog classes dialog_wrapper : &quot;&quot; , # The outer element dialog : &quot;&quot; , # Dialog element # Box classes - see box component: box : &quot;&quot; , header : &quot;&quot; , row : &quot;&quot; , body : &quot;&quot; , footer : &quot;&quot; , header_title : &quot;&quot; , link : &quot;&quot; , } Defaults to %{body: nil, box: nil, dialog: nil, dialog_wrapper: nil, footer: nil, header: nil, header_title: nil, link: nil, row: nil} . is_backdrop ( :boolean ) - Generates a medium backdrop background color. Defaults to false . is_dark_backdrop ( :boolean ) - Generates a darker backdrop background color. Defaults to false . is_medium_backdrop ( :boolean ) - Generates a medium backdrop background color (default). Defaults to false . is_light_backdrop ( :boolean ) - Generates a lighter backdrop background color. Defaults to false . is_fast ( :boolean ) - Generates fast fade transitions for backdrop and content. Defaults to false . is_modal ( :boolean ) - Generates a modal dialog; clicking the backdrop (if used) or outside of the dialog will not close the dialog. Defaults to false . is_escapable ( :boolean ) - Closes the content when pressing the Escape key. Defaults to false . focus_first ( :string ) - Focus the first element after opening the dialog. Pass a selector to match the element. is_narrow ( :boolean ) - Generates a smaller dialog, width: 320px (default: 440px ). Defaults to false . is_wide ( :boolean ) - Generates a wider dialog, width: 640px (default: 440px ). Defaults to false . max_height ( :string ) - Maximum height of the dialog as CSS value. Use unit vh or % . Defaults to &quot;80vh&quot; . max_width ( :string ) - Maximum width of the dialog as CSS value. Use unit vh or % . Defaults to &quot;90vw&quot; . Global attributes are accepted. Slots header_title - Dialog header title. Uses box/1 header_title slot.Note that slot header is automatically created to ensure the correct close button.Accepts attributes: rest ( :any ) - Additional attributes. body - Dialog body. Uses box/1 body slot. Accepts attributes: rest ( :any ) - Additional attributes. row - Dialog row. Uses box/1 row slot. Accepts attributes: rest ( :any ) - Additional attributes. footer - Dialog footer. Uses box/1 footer slot. Accepts attributes: rest ( :any ) - Additional attributes. inner_block - Unstructured dialog content. Uses box/1 inner_block slot. Reference Primer/CSS Box overlay Status Feature complete.","ref":"PrimerLive.Component.html#dialog/1","title":"PrimerLive.Component.dialog/1","type":"function"},{"doc":"Generates a drawer with configuration options for backdrop, position and behavior. &lt; . drawer &gt; &lt; . drawer_content &gt; Content &lt; / . drawer_content &gt; &lt; / . drawer &gt; Showing and hiding is done with JS function Prompt from dialogic-js , included in primer-js (see Installation). Function Prompt.show requires a selector. When placed inside the drawer component, the selector can be replaced with this : &lt; . drawer id = &quot;my-drawer&quot; &gt; &lt; . drawer_content &gt; &lt; . button onclick = &quot;Prompt.hide(this)&quot; &gt; Close &lt; / . button &gt; Content &lt; / . drawer_content &gt; &lt; / . drawer &gt; &lt; . button onclick = &quot;Prompt.show(&#39;#my-drawer&#39;)&quot; &gt; Open drawer &lt; / . button &gt; Examples By default the drawer width is defined by its content. To set an explicit width of the drawer content: &lt; . drawer &gt; &lt; . drawer_content width = &quot;300px&quot; &gt; ... &lt; / . drawer_content &gt; &lt; / . drawer &gt; Add a backdrop. Optionally add is_light_backdrop or is_dark_backdrop : &lt; . drawer is_backdrop is_dark_backdrop &gt; ... &lt; / . drawer &gt; Create a modal drawer; clicking the backdrop (if used) or outside of the drawer will not close the drawer: &lt; . drawer is_modal &gt; ... &lt; / . drawer &gt; Close the drawer with the Escape key: &lt; . drawer is_escapable &gt; ... &lt; / . drawer &gt; Create faster slide in and out: &lt; . drawer is_fast &gt; ... &lt; / . drawer &gt; Focus the first element after opening the drawer. Pass a selector to match the element. &lt; . drawer focus_first = &quot;#login_first_name&quot; &gt; ... &lt; / . drawer &gt; or &lt; . drawer focus_first = &quot;[name=login \\[ first_name \\] ]&quot; &gt; ... &lt; / . drawer &gt; Create a local drawer (inside a container) with is_local : &lt; div style = &quot;position: relative; overflow-x: hidden;&quot; &gt; Page content &lt; . drawer is_local &gt; &lt; . drawer_content &gt; Content &lt; / . drawer_content &gt; &lt; / . drawer &gt; &lt; / div &gt; Create a push drawer - where the drawer content pushes the adjacent content aside when it opens - with attr is_push and the content to be pushed inside &lt;.drawer&gt; : &lt; div style = &quot;position: relative; overflow-x: hidden;&quot; &gt; &lt; . drawer is_push &gt; Page content &lt; . drawer_content &gt; Content &lt; / . drawer_content &gt; &lt; / . drawer &gt; &lt; / div &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . is_far_side ( :boolean ) - Opens the drawer at the far end of the reading direction. Defaults to false . is_backdrop ( :boolean ) - Generates a medium backdrop background color. Defaults to false . is_dark_backdrop ( :boolean ) - Generates a darker backdrop background color. Defaults to false . is_medium_backdrop ( :boolean ) - Generates a medium backdrop background color (default). Defaults to false . is_light_backdrop ( :boolean ) - Generates a lighter backdrop background color. Defaults to false . is_fast ( :boolean ) - Generates fast fade transitions for backdrop and content. Defaults to false . is_modal ( :boolean ) - Generates a modal drawer; clicking the backdrop (if used) or outside of the drawer will not close the drawer. Defaults to false . is_escapable ( :boolean ) - Closes the content when pressing the Escape key. Defaults to false . is_local ( :boolean ) - Adds styles for a drawer inside a a container. Defaults to false . is_push ( :boolean ) - Adds styles for a push drawer inside a a container. Defaults to false . focus_first ( :string ) - Focus the first element after opening the drawer. Pass a selector to match the element. Global attributes are accepted. Slots inner_block - Drawer content and any adjacent elements. Use drawer_content/1 for the content to be displayed inside the drawer. Reference Neither Primer CSS nor Primer React provide a drawer component. However, a drawer is used on their documentation site (mobile view).","ref":"PrimerLive.Component.html#drawer/1","title":"PrimerLive.Component.drawer/1","type":"function"},{"doc":"Drawer content. See drawer/1 . Attributes class ( :string ) - Additional classname. Defaults to nil . width ( :string ) - Sets the width of the drawer as CSS value. Add unit px or rem or other size unit. By default the drawer width is defined by its content. Defaults to nil . Global attributes are accepted. Slots inner_block - Drawer content.","ref":"PrimerLive.Component.html#drawer_content/1","title":"PrimerLive.Component.drawer_content/1","type":"function"},{"doc":"Generates a dropdown menu. Dropdowns are small context menus that can be used for navigation and actions. They are a simple alternative to select menus . Menu items are rendered as link element. &lt; . dropdown &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :item href = &quot;#url&quot; &gt; Item 1 &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Item 2 &lt; / :item &gt; &lt; / . dropdown &gt; Examples Menu links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add a menu title by passing title to the menu slot: &lt; . dropdown &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :menu title = &quot;Menu title&quot; / &gt; ... &lt; / . dropdown &gt; Change the position of the menu relative to the dropdown toggle: &lt; :menu position = &quot;e&quot; / &gt; Create dividers with item slot attribute is_divider . A divider cannot have contents. &lt; . dropdown &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; ... &lt; :item is_divider / &gt; ... &lt; / . dropdown &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for dropdown elements. Any provided value will be appended to the default classname, except for toggle that will override the default class &quot;btn&quot;. Default map: %{ caret : &quot;&quot; , # Arrow in toggle button divider : &quot;&quot; , # List divider item (li element) dropdown : &quot;&quot; , # Dropdown wrapper header : &quot;&quot; , # Menu header item : &quot;&quot; , # Link item, placed inside li element menu : &quot;&quot; , # List container (ul element) toggle : &quot;&quot; # Toggle (open) button } Defaults to %{caret: nil, divider: nil, dropdown: nil, header: nil, item: nil, menu: nil, toggle: nil} . Global attributes are accepted. Slots toggle (required) - Generates a toggle element (default with button appearance) using the slot content as label. Any custom class will override the default class &quot;btn&quot;. menu - Generates a menu element. Accepts attributes: title ( :string ) - Generates a menu header with specified title. position ( :string ) - Position of the menu relative to the dropdown toggle. Default: &quot;se&quot;. Must be one of &quot;se&quot; , &quot;ne&quot; , &quot;e&quot; , &quot;sw&quot; , &quot;s&quot; , or &quot;w&quot; . item (required) - Menu item content. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_divider ( :boolean ) - Generates a divider element. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. Reference Primer/CSS Dropdown Status Feature complete.","ref":"PrimerLive.Component.html#dropdown/1","title":"PrimerLive.Component.dropdown/1","type":"function"},{"doc":"Generates a vertical list of filters. Filter list items are rendered as link element. &lt; . filter_list aria_label = &quot;Menu&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; One &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Two &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Three &lt; / :item &gt; &lt; / . filter_list &gt; Examples Filter links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add counts to the links: &lt; . filter_list aria_label = &quot;Menu&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected count = &quot;99&quot; &gt; First filter &lt; / :item &gt; &lt; :item href = &quot;#url&quot; count = { 3 } &gt; Second filter &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Third filter &lt; / :item &gt; &lt; / . filter_list &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for filter list elements. Any provided value will be appended to the default classname. Default map: %{ filter_list : &quot;&quot; , # Outer container (ul element) item : &quot;&quot; , # Filter list item element (a element) count : &quot;&quot; , # Filter list item count element (span element) } Defaults to %{count: nil, filter_list: nil, item: nil} . aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . Global attributes are accepted. Slots item (required) - Filter list item content. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_selected ( :boolean ) - Shows the selected state. count ( :any ) - Integer or string. Displays a number at the far end of the filter link. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. Reference Primer/CSS Navigation Status Feature complete.","ref":"PrimerLive.Component.html#filter_list/1","title":"PrimerLive.Component.filter_list/1","type":"function"},{"doc":"Generates a form group: a wrapper around one or more inputs. Automatically adds a label based on supplied form and field, with the option to set a custom label. &lt; . form_group field = &quot;first_name&quot; &gt; &lt; . text_input field = &quot;first_name&quot; / &gt; &lt; / . form_group &gt; Examples With a Phoenix.HTML.Form : &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . form_group form = { f } field = { :first_name } &gt; &lt; . text_input form = { f } field = { :first_name } phx_debounce = &quot;blur&quot; autocomplete = &quot;off&quot; / &gt; &lt; / . form_group &gt; &lt; / . form &gt; Custom label: &lt; . form_group form = { f } field = { :first_name } label = &quot;Enter your first name&quot; &gt; ... &lt; / . form_group &gt; Hide the label: &lt; . form_group form = { f } field = { :first_name } is_hide_label &gt; ... &lt; / . form_group &gt; Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. label ( :string ) - Custom label. Note that a label is automatically generated when using field . Defaults to nil . is_hide_label ( :boolean ) - Omits the label when using field . Defaults to false . class ( :string ) - Additional classname. Defaults to nil . for ( :string ) - Internally used by text_input/1 and textarea/1 when using is_form_group or form_group . Label attribute to associate the label with the input. for should be the same as the input's id . Defaults to nil . classes ( :map ) - Additional classnames for form group elements. Any provided value will be appended to the default classname. Default map: %{ group : &quot;&quot; , # Form group element header : &quot;&quot; , # Header element containing the group label body : &quot;&quot; , # Input wrapper label : &quot;&quot; , # Form group label } Defaults to %{body: nil, group: nil, header: nil, label: nil, validation_message: nil} . Global attributes are accepted. Slots inner_block (required) - Form group content. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#form_group/1","title":"PrimerLive.Component.form_group/1","type":"function"},{"doc":"Generates a navigational header, to be placed at the top of the page. &lt; . header &gt; &lt; :item &gt; Item 1 &lt; / :item &gt; &lt; :item &gt; Item 2 &lt; / :item &gt; &lt; :item &gt; Item 3 &lt; / :item &gt; &lt; / . header &gt; Examples Stretch an item with attribute is_full : &lt; :item is_full &gt; Stretched item &lt; / :item &gt; A space can also be generated with an &quot;empty&quot; item: &lt; :item is_full / &gt; Links can be placed inside items. Use :let to get access to the classes.link class. With Phoenix.Component.link/1 : &lt; :item :let = { classes } &gt; &lt; . link href = &quot;/&quot; class = { classes . link } &gt; Regular anchor link &lt; / . link &gt; &lt; / :item &gt; &lt; :item :let = { classes } &gt; &lt; . link navigate = { Routes . page_path ( @socket , :index ) } class = { [ classes . link , &quot;underline&quot; ] } &gt; Home &lt; / . link &gt; &lt; / :item &gt; Inputs can be placed in the same way, using :let to get access to the classes.input class: &lt; :item :let = { classes } &gt; &lt; . text_input form = { :user } field = { :first_name } type = &quot;search&quot; class = { classes . input } / &gt; &lt; / :item &gt; Attributes class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for header elements. Any provided value will be appended to the default classname. Default map: %{ header : &quot;&quot; , # The wrapping element item : &quot;&quot; , # Header item element link : &quot;&quot; , # Link inside an item input : &quot;&quot; , # Input element inside an item } Defaults to %{header: nil, item: nil, link: nil} . Global attributes are accepted. Slots item - Header item. Accepts attributes: is_full ( :boolean ) - Stretches the item to maximum. rest ( :any ) - Additional HTML attributes added to the item element. Lets &lt; :item :let = { classes } / &gt; Yields a classes map, containing the merged values of default classnames, plus any value supplied to the classes component attribute. &lt; . header classes = { %{ link : &quot;link-x&quot; } } &gt; &lt; :item :let = { classes } &gt; &lt; . link href = &quot;/&quot; class = { [ &quot;my-link&quot; , classes . link ] } &gt; Home &lt; / . link &gt; &lt; / :item &gt; &lt; / . header &gt; Results in: &lt; div class = &quot;Header&quot; &gt; &lt; div class = &quot;Header-item&quot; &gt; &lt; a href = &quot;/&quot; class = &quot;my-link Header-link link-x&quot; &gt; Home &lt; / a &gt; &lt; / div &gt; &lt; / div &gt; Reference Primer/CSS Header Status Feature complete.","ref":"PrimerLive.Component.html#header/1","title":"PrimerLive.Component.header/1","type":"function"},{"doc":"Generates a validation message for a form input. This component is incorporated in &quot;singular inputs&quot; text_input/1 , textarea/1 and select/1 . It can be used as standalone component for inputs where the position of the validation feedback is not so obvious. A validation error message is automatically added when using a changeset with an error state. The message text is taken from the changeset errors. To show the default validation message: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; ! -- INPUTS -- &gt; &lt; . input_validation_message form = { @form } field = { :availability } / &gt; &lt; / . form &gt; To show a custom error message: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; ! -- INPUTS -- &gt; &lt; . input_validation_message form = { @form } field = { :availability } validation_message = { fn field_state -&gt; if ! field_state . valid? , do : &quot;Please select your availability&quot; end } / &gt; &lt; / . form &gt; Similarly, to show a custom validation success message: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; ! -- INPUTS -- &gt; &lt; . input_validation_message form = { @form } field = { :availability } validation_message = { fn field_state -&gt; if field_state . valid? , do : &quot;Great!&quot; end } / &gt; &lt; / . form &gt; Attributes class ( :string ) - Classname. Defaults to nil . field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. validation_message ( :any ) - Function to write a custom validation message (in case of error or success). See text_input/1 . input_id ( :string ) - If the associated input has an id, pass it here as &quot;input_id&quot;. Global attributes are accepted.","ref":"PrimerLive.Component.html#input_validation_message/1","title":"PrimerLive.Component.input_validation_message/1","type":"function"},{"doc":"Issue labels are used for adding labels to issues and pull requests. They also come with emoji support. And issue label is basically labels without a border. It expects background and foreground colors. &lt; . issue_label &gt; Label &lt; / . issue_label &gt; Examples Add colors: &lt; . issue_label color - bg - accent - emphasis color - fg - on - emphasis &gt; Label &lt; / . issue_label &gt; Larger label: &lt; . issue_label is_big &gt; Label &lt; / . issue_label &gt; Attributes class ( :string ) - Additional classname. is_big ( :boolean ) - Larger issue label. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Label content. Reference Primer/CSS Labels Status Feature complete.","ref":"PrimerLive.Component.html#issue_label/1","title":"PrimerLive.Component.issue_label/1","type":"function"},{"doc":"Generates a label element. Labels add metadata or indicate status of items and navigational elements. &lt; . label &gt; Label &lt; / . label &gt; When using label alongside Phoenix.HTML.Form.label/2 , use a prefix, for example: use PrimerLive alias PrimerLive.Component , as : P ... &lt; P . label &gt; Label &lt; / P . label &gt; Examples Create a colored label: &lt; . label is_success &gt; Label &lt; / . label &gt; Create a larger label: &lt; . label is_large &gt; Label &lt; / . label &gt; Create an inline label: &lt; p &gt; Lorem Ipsum is simply &lt; . label is_inline &gt; dummy text &lt; / . label &gt; of the printing and typesetting industry . Lorem Ipsum has been the industry &#39; s standard dummy text . &lt; / p &gt; Attributes class ( :string ) - Additional classname. is_primary ( :boolean ) - Generates a label with a stronger border. Defaults to false . is_secondary ( :boolean ) - Generates a label with a subtler text color. Defaults to false . is_accent ( :boolean ) - Accent color. Defaults to false . is_success ( :boolean ) - Success color. Defaults to false . is_attention ( :boolean ) - Attention color. Defaults to false . is_severe ( :boolean ) - Severe color. Defaults to false . is_danger ( :boolean ) - Danger color. Defaults to false . is_open ( :boolean ) - Open color. Defaults to false . is_closed ( :boolean ) - Closed color. Defaults to false . is_done ( :boolean ) - Done color. Defaults to false . is_sponsors ( :boolean ) - Sponsors color. Defaults to false . is_large ( :boolean ) - Larger label. Defaults to false . is_inline ( :boolean ) - For use in running text. Adapts line height and font size to text. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Label content. Reference Primer/CSS Labels Status Feature complete.","ref":"PrimerLive.Component.html#label/1","title":"PrimerLive.Component.label/1","type":"function"},{"doc":"Generates a responsive-friendly page layout with 2 columns. &lt; . layout &gt; &lt; :main &gt; Main content &lt; / :main &gt; &lt; :sidebar &gt; Sidebar content &lt; / :sidebar &gt; &lt; / . layout &gt; Examples The position of the sidebar (left or right on desktop) is set by CSS (and can be changed with attribute is_sidebar_position_end ). To place the sidebar at the right: &lt; . layout is_sidebar_position_end &gt; &lt; :main &gt; Main content &lt; / :main &gt; &lt; :sidebar &gt; Sidebar content &lt; / :sidebar &gt; &lt; / . layout &gt; To place the sidebar slot below the main slot on small screens, use attribute is_sidebar_position_flow_row_end : &lt; . layout is_sidebar_position_flow_row_end &gt; &lt; :main &gt; Main content &lt; / :main &gt; &lt; :sidebar &gt; Sidebar content &lt; / :sidebar &gt; &lt; / . layout &gt; When using a divider, use attribute is_divided to make the divider element visible. Extra divider modifiers for vertical layout (on small screens): is_divided creates a 1px border between main and sidebar is_divided with is_flow_row_hidden hides the divider is_divided with is_flow_row_shallow shows a filled 8px divider &lt; . layout is_divided &gt; &lt; :main &gt; Main content &lt; / :main &gt; &lt; :divider &gt; &lt; / :divider &gt; &lt; :sidebar &gt; Sidebar content &lt; / :sidebar &gt; &lt; / . layout &gt; The modifiers is_centered_xx create a wrapper around main to center its content up to a maximum width. Use with .container-xx classes to restrict the size of the content: &lt; . layout is_centered_md &gt; &lt; :main &gt; &lt; div class = &quot;container-md&quot; &gt; Centered md &lt; / div &gt; &lt; / :main &gt; &lt; :sidebar &gt; Sidebar content &lt; / :sidebar &gt; &lt; / . layout &gt; Layouts can be nested. Nested layout, example 1: &lt; . layout &gt; &lt; :main &gt; &lt; . layout is_sidebar_position_end is_narrow_sidebar &gt; &lt; :main &gt; Main content &lt; / :main &gt; &lt; :sidebar &gt; Metadata sidebar &lt; / :sidebar &gt; &lt; / . layout &gt; &lt; / :main &gt; &lt; :sidebar &gt; Default sidebar &lt; / :sidebar &gt; &lt; / . layout &gt; Nested layout, example 2: &lt; . layout &gt; &lt; :main &gt; &lt; . layout is_sidebar_position_end is_flow_row_until_lg is_narrow_sidebar &gt; &lt; :main &gt; Main content &lt; / :main &gt; &lt; :sidebar &gt; Metadata sidebar &lt; / :sidebar &gt; &lt; / . layout &gt; &lt; / :main &gt; &lt; :sidebar &gt; Default sidebar &lt; / :sidebar &gt; &lt; / . layout &gt; Attributes class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for layout elements. Any provided value will be appended to the default classname. Default map: %{ layout : &quot;&quot; , # Layout wrapper main : &quot;&quot; , # Main element main_center_wrapper : &quot;&quot; , # Wrapper for displaying content centered sidebar : &quot;&quot; , # Sidebar element divider : &quot;&quot; , # Divider element } Defaults to %{divider: nil, layout: nil, main: nil, main_center_wrapper: nil, sidebar: nil} . is_divided ( :boolean ) - Use is_divided in conjunction with the layout_item/1 element with attribute divider to show a divider between the main content and the sidebar. Generates a 1px line between main and sidebar. Defaults to false . is_narrow_sidebar ( :boolean ) - Smaller sidebar size. Widths: md: 240px, lg: 256px. Defaults to false . is_wide_sidebar ( :boolean ) - Wider sidebar size. Widths: md: 296px, lg: 320px, xl: 344px. Defaults to false . is_gutter_none ( :boolean ) - Changes the gutter size to 0px. Defaults to false . is_gutter_condensed ( :boolean ) - Changes the gutter size to 16px. Defaults to false . is_gutter_spacious ( :boolean ) - Changes the gutter sizes to: md: 16px, lg: 32px, xl: 40px. Defaults to false . is_sidebar_position_start ( :boolean ) - Places the sidebar at the start (commonly at the left) (default). Defaults to false . is_sidebar_position_end ( :boolean ) - Places the sidebar at the end (commonly at the right) on desktop. Defaults to false . is_sidebar_position_flow_row_start ( :boolean ) - When stacked, render the sidebar first (default). Defaults to false . is_sidebar_position_flow_row_end ( :boolean ) - When stacked, render the sidebar last. Defaults to false . is_sidebar_position_flow_row_none ( :boolean ) - When stacked, hide the sidebar. Defaults to false . is_flow_row_until_md ( :boolean ) - Stacks when container is md. Defaults to false . is_flow_row_until_lg ( :boolean ) - Stacks when container is lg. Defaults to false . is_centered_lg ( :boolean ) - Generates a wrapper around main to keep its content centered up to max width &quot;lg&quot;. Defaults to false . is_centered_md ( :boolean ) - Generates a wrapper around main to keep its content centered up to max width &quot;md&quot;. Defaults to false . is_centered_xl ( :boolean ) - Generates a wrapper around main to keep its content centered up to max width &quot;xl&quot;. Defaults to false . is_flow_row_hidden ( :boolean ) - On a small screen (up to 544px). Hides the horizontal divider. Defaults to false . is_flow_row_shallow ( :boolean ) - On a small screen (up to 544px). Generates a filled 8px horizontal divider. Defaults to false . Global attributes are accepted. Slots main - Generates a main element. Default gutter sizes: md: 16px, lg: 24px (change with is_gutter_none , is_gutter_condensed and is_gutter_spacious ). Stacks when container is sm (change with is_flow_row_until_md and is_flow_row_until_lg ). Accepts attributes: order ( :any ) - Markup order, defines in what order the slot is rendered in HTML. Keyboard navigation follows the markup order. Decide carefully how the focus order should be be by deciding whether main or sidebar comes first in code. The markup order won't affect the visual position. Default value: 2.Must be one of 1 , 2 , &quot;1&quot; , or &quot;2&quot; . divider - Generates a divider element. The divider will only be shown with option is_divided . Generates a line between the main and sidebar elements - horizontal when the elements are stacked and vertical when they are shown side by side. sidebar - Generates a sidebar element. Widths: md: 256px, lg: 296px (change with is_narrow_sidebar and is_wide_sidebar ). Accepts attributes: order ( :integer ) - See main slot. Default value: 1.Must be one of 1 , or 2 . Reference Primer/CSS Layout Status Feature complete.","ref":"PrimerLive.Component.html#layout/1","title":"PrimerLive.Component.layout/1","type":"function"},{"doc":"Generates a vertical list of navigational links. Menu items are rendered as link element. &lt; . menu aria_label = &quot;Site navigation&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Account &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Emails &lt; / :item &gt; &lt; / . menu &gt; Examples Menu links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add other types of content, such as icons and counters: &lt; . menu &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; &lt; . octicon name = &quot;comment-discussion-16&quot; / &gt; &lt; span &gt; Conversation &lt; / span &gt; &lt; . counter &gt; 2 &lt; / . counter &gt; &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; &lt; . octicon name = &quot;check-circle-16&quot; / &gt; &lt; span &gt; Done &lt; / span &gt; &lt; . counter &gt; 99 &lt; / . counter &gt; &lt; / :item &gt; &lt; / . menu &gt; Add a heading: &lt; . menu aria_label = &quot;Site navigation&quot; &gt; &lt; :heading &gt; Menu heading &lt; / :heading &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Account &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Emails &lt; / :item &gt; &lt; / . menu &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for underline nav elements. Any provided value will be appended to the default classname. Default map: %{ menu : &quot;&quot; , # Outer container (nav element) item : &quot;&quot; , # Menu item element heading : &quot;&quot; , # Heading element } Defaults to %{heading: nil, item: nil, menu: nil} . aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . Global attributes are accepted. Slots item (required) - Menu content. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_selected ( :boolean ) - Shows the selected state. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. heading - Menu heading. Reference Primer/CSS Navigation Status Feature complete.","ref":"PrimerLive.Component.html#menu/1","title":"PrimerLive.Component.menu/1","type":"function"},{"doc":"Renders an icon from the set of GitHub icons, 512 including all size variations. See PrimerLive.Octicons for the complete list. &lt; . octicon name = &quot;comment-16&quot; / &gt; Examples Pass the icon name with the size: icon &quot;alert-fill&quot; with size &quot;12&quot; becomes &quot;alert-fill-12&quot;: &lt; . octicon name = &quot;alert-fill-12&quot; / &gt; Icon &quot;pencil&quot; with size 24: &lt; . octicon name = &quot;pencil-24&quot; / &gt; Custom class: &lt; . octicon name = &quot;pencil-24&quot; class = &quot;app-icon&quot; / &gt; Attributes name ( :string ) (required) - Icon name, e.g. &quot;arrow-left-24&quot;. See available icons . class ( :string ) - Additional classname. Global attributes are accepted. Reference List of Primer icons Primer/Octicons Usage Status Feature complete.","ref":"PrimerLive.Component.html#octicon/1","title":"PrimerLive.Component.octicon/1","type":"function"},{"doc":"Generates a control to navigate search results. &lt; . pagination page_count = { @page_count } current_page = { @current_page } link_path = { fn page_num -&gt; &quot;/page/ \#{ page_num } &quot; end } / &gt; Features Configure the page number ranges for siblings and sides Optionally disable page number display (minimal UI) Custom labels Custom classnames for all elements If pages in the center (controlled by sibling_count ) collide with pages near the sides (controlled by side_count ), the center section will be pushed away from the side. Examples Simplified paginations, showing Next / Previous buttons: &lt; . pagination ... is_numbered = &quot;false&quot; / &gt; Configure the number of sibling and boundary page numbers to show: &lt; . pagination ... sibling_count = &quot;1&quot; # default: 2 side_count = &quot;2&quot; # default 1 / &gt; Provide custom labels: &lt; . pagination ... labels = { %{ next_page : &quot;Nächste Seite&quot; , previous_page : &quot;Vorherige Seite&quot; } } / &gt; Attributes page_count ( :integer ) (required) - Result page count. current_page ( :integer ) (required) - Current page number. link_path ( :any ) (required) - Function that returns a path for the given page number. The link builder uses Phoenix.Component.link/1 with attribute navigate . Extra options can be passed with link_options . Function signature: (page_number) -&gt; path side_count ( :integer ) - Number of page links at both ends. Defaults to 1 . sibling_count ( :integer ) - Number of page links at each side of the current page number element. Defaults to 2 . is_numbered ( :any ) - Boolean atom or string. Showing page numbers. Defaults to true . class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for pagination elements. Any provided value will be appended to the default classname. Default map: %{ gap : &quot;&quot; , pagination_container : &quot;&quot; , pagination : &quot;&quot; , previous_page : &quot;&quot; , next_page : &quot;&quot; , page : &quot;&quot; } Defaults to %{gap: nil, next_page: nil, page: nil, pagination: nil, pagination_container: nil, previous_page: nil} . labels ( :map ) - Textual labels. Any provided value will override the default text. Defaults to %{aria_label_container: &quot;Navigation&quot;, aria_label_next_page: &quot;Next page&quot;, aria_label_page: &quot;Page {page_number}&quot;, aria_label_previous_page: &quot;Previous page&quot;, gap: &quot;…&quot;, next_page: &quot;Next&quot;, previous_page: &quot;Previous&quot;} . link_options ( :map ) - Link options. Defaults to %{replace: false} . Global attributes are accepted. Reference Primer/CSS Pagination Status Feature complete.","ref":"PrimerLive.Component.html#pagination/1","title":"PrimerLive.Component.pagination/1","type":"function"},{"doc":"Generates a larger &quot;parent&quot; avatar with a smaller &quot;child&quot; overlaid on top. Examples Use slots parent and child to create the avatars using avatar/1 attributes: &lt; . parent_child_avatar &gt; &lt; :parent src = &quot;emma.jpg&quot; size = &quot;7&quot; / &gt; &lt; :child src = &quot;kim.jpg&quot; size = &quot;2&quot; / &gt; &lt; / . parent_child_avatar &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . Global attributes are accepted. Slots parent - Generates a parent avatar. Accepts attributes: size ( :integer ) - Avatar size - see avatar/1 . rest ( :any ) - Additional HTML attributes added to the parent avatar. child - Generates a child avatar. Accepts attributes: size ( :integer ) - Avatar size - see avatar/1 . rest ( :any ) - Additional HTML attributes added to the child avatar. Reference Primer/CSS Avatars Status Feature complete.","ref":"PrimerLive.Component.html#parent_child_avatar/1","title":"PrimerLive.Component.parent_child_avatar/1","type":"function"},{"doc":"Generates a progress bar to visualize task completion. The item slot creates the colored bar. Its width is a percentage value (0 - 100). &lt; . progress aria_label = &quot;Tasks: 8 of 10 complete&quot; &gt; &lt; :item width = &quot;50&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Examples The default bar state is &quot;success&quot; (green). Possible states: &quot;info&quot; - blue &quot;success&quot; - green &quot;warning&quot; - ocher &quot;error&quot; - red &lt; . progress &gt; &lt; :item width = &quot;50&quot; state = &quot;error&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Use multiple items to show a multicolored bar: &lt; . progress &gt; &lt; :item width = &quot;50&quot; state = &quot;success&quot; &gt; &lt; / :item &gt; &lt; :item width = &quot;30&quot; state = &quot;warning&quot; &gt; &lt; / :item &gt; &lt; :item width = &quot;10&quot; state = &quot;error&quot; &gt; &lt; / :item &gt; &lt; :item width = &quot;5&quot; state = &quot;info&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Create a large progress bar: &lt; . progress is_large &gt; &lt; :item width = &quot;50&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Create a small progress bar: &lt; . progress is_small &gt; &lt; :item width = &quot;50&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Create an inline progress bar: &lt; span class = &quot;text-small color-fg-muted mr-2&quot; &gt; 4 of 16 &lt; / span &gt; &lt; . progress is_inline style = &quot;width: 160px;&quot; &gt; &lt; :item width = &quot;25&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Attributes aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for progress elements. Any provided value will be appended to the default classname. Default map: %{ progress : &quot;&quot; , # Outer container item : &quot;&quot; , # Colored bar element state_success : &quot;&quot; , # Color bar modifier state_info : &quot;&quot; , # Color bar modifier state_warning : &quot;&quot; , # Color bar modifier state_error : &quot;&quot; , # Color bar modifier } Defaults to %{item: nil, progress: nil, state_error: nil, state_info: nil, state_success: nil, state_warning: nil} . is_large ( :boolean ) - Creates a large progress bar. Defaults to false . is_small ( :boolean ) - Creates a small progress bar. Defaults to false . is_inline ( :boolean ) - Creates an inline progress bar, to be used next to other elements. The &quot;progress&quot; element must have a width, for example: &lt; . progress is_inline style = &quot;width: 160px;&quot; &gt; &lt; :item width = &quot;25&quot; &gt; &lt; / :item &gt; &lt; / . progress &gt; Defaults to false . Global attributes are accepted. Slots item (required) - Colored bar. Accepts attributes: width ( :any ) - String or integer. Percentage value (0 - 100). state ( :string ) - Color mapping: &quot;info&quot; - blue &quot;success&quot; - green &quot;warning&quot; - ocher &quot;error&quot; - red Must be one of &quot;info&quot; , &quot;success&quot; , &quot;warning&quot; , or &quot;error&quot; . Reference Primer/CSS Progress Status Feature complete.","ref":"PrimerLive.Component.html#progress/1","title":"PrimerLive.Component.progress/1","type":"function"},{"doc":"Generates a radio button. Wrapper around Phoenix.HTML.Form.radio_button/4 . &lt; . radio_button name = &quot;role&quot; value = &quot;admin&quot; / &gt; &lt; . radio_button name = &quot;role&quot; value = &quot;editor&quot; / &gt; Examples Set the checked state: &lt; . radio_button name = &quot;role&quot; value = &quot;admin&quot; / &gt; &lt; . radio_button name = &quot;role&quot; value = &quot;editor&quot; checked / &gt; Using the radio button with form data. This will automatically create the radio button label: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . radio_button form = { f } field = { :role } value = &quot;admin&quot; / &gt; &lt; . radio_button form = { f } field = { :role } value = &quot;editor&quot; / &gt; &lt; / . form &gt; Pass a custom radio button label with the label slot: &lt; . radio_button form = { :user } field = { :role } &gt; &lt; :label &gt; Some label &lt; / :label &gt; &lt; / . radio_button &gt; Add emphasis to the label: &lt; . radio_button name = &quot;role&quot; is_emphasised_label / &gt; Add a hint below the label: &lt; . radio_button name = &quot;role&quot; &gt; &lt; :label &gt; Some label &lt; / :label &gt; &lt; :hint &gt; Add your &lt; strong &gt; resume &lt; / strong &gt; below &lt; / :hint &gt; &lt; / . radio_button &gt; Reveal extra details when the radio button is checked: &lt; . radio_button name = &quot;role&quot; &gt; &lt; :label &gt; Some label &lt; / :label &gt; &lt; :disclosure &gt; &lt; span class = &quot;d-block mb-1&quot; &gt; Available hours per week &lt; / span &gt; &lt; . text_input is_contrast size = &quot;3&quot; / &gt; &lt; span class = &quot;text-small color-fg-muted pl-2&quot; &gt; hours per week &lt; / span &gt; &lt; / :disclosure &gt; &lt; / . radio_button &gt; Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. value ( :string ) - Input value. Defaults to nil . is_emphasised_label ( :boolean ) - Adds emphasis to the label. Defaults to false . is_omit_label ( :boolean ) - Omits any label. Defaults to false . class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for radio button elements. Any provided value will be appended to the default classname. Default map: %{ label : &quot;&quot; , # Input label input : &quot;&quot; , # Radio button input element hint : &quot;&quot; , # Hint message container disclosure : &quot;&quot; # Disclosure container (inline) } Defaults to %{disclosure: nil, hint: nil, input: nil, label: nil} . Global attributes are accepted. Slots label - Custom radio button label. Overides the derived label when using a form and field . Accepts attributes: rest ( :any ) - Additional HTML attributes added to the label element. hint - Adds text below the radio button label. Enabled when a label is displayed. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the hint element. disclosure - Extra label content to be revealed when the radio button is checked. Enabled when a label is displayed.Note that the label element can only contain inline child elements.Accepts attributes: rest ( :any ) - Additional HTML attributes added to the disclosure wrapper element. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#radio_button/1","title":"PrimerLive.Component.radio_button/1","type":"function"},{"doc":"Groups radio buttons in a tab-like row. Radio buttons are generated from the radio_button slot: &lt; . radio_group &gt; &lt; :radio_button name = &quot;role&quot; value = &quot;admin&quot; &gt; &lt; / :radio_button &gt; &lt; :radio_button name = &quot;role&quot; value = &quot;editor&quot; &gt; &lt; / :radio_button &gt; &lt; / . radio_group &gt; Examples Using a Phoenix.HTML.Form , attributes form and field are passed from radio group to the radio buttons, and labels are generated automatically: &lt; . form let = { f } for = { @changeset } &gt; &lt; . radio_group form = { f } field = { :role } &gt; &lt; :radio_button value = &quot;admin&quot; &gt; &lt; / :radio_button &gt; &lt; :radio_button value = &quot;editor&quot; &gt; &lt; / :radio_button &gt; &lt; / . radio_group &gt; &lt; / . form &gt; Generates: &lt; form method = &quot;post&quot; errors = &quot;&quot; &gt; &lt; div class = &quot;radio-group&quot; &gt; &lt; input class = &quot;radio-input&quot; id = &quot;demo_user_role_admin&quot; name = &quot;demo_user[role]&quot; type = &quot;radio&quot; value = &quot;admin&quot; &gt; &lt; label class = &quot;radio-label&quot; for = &quot;demo_user_role_admin&quot; &gt; Admin &lt; / label &gt; &lt; input class = &quot;radio-input&quot; id = &quot;demo_user_role_editor&quot; name = &quot;demo_user[role]&quot; type = &quot;radio&quot; value = &quot;editor&quot; &gt; &lt; label class = &quot;radio-label&quot; for = &quot;demo_user_role_editor&quot; &gt; Editor &lt; / label &gt; &lt; / div &gt; &lt; / form &gt; Use custom label with the radio_button slot inner_block : &lt; . radio_group &gt; &lt; :radio_button name = &quot;role&quot; value = &quot;admin&quot; &gt; My role is Admin &lt; / :radio_button &gt; &lt; :radio_button name = &quot;role&quot; value = &quot;editor&quot; &gt; My role is Editor &lt; / :radio_button &gt; &lt; / . radio_group &gt; Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for radio group elements. Any provided value will be appended to the default classname. Default map: %{ radio_group : &quot;&quot; , # Wrapper label : &quot;&quot; , # Radio button label radio_input : &quot;&quot; , # Radio button input } Defaults to %{label: nil, radio_group: nil, radio_input: nil} . id_prefix ( :string ) - Attribute id prefix to create unique ids. Defaults to nil . Global attributes are accepted. Slots radio_button - Generates a radio button. Accepts attributes: value ( :string ) - Radio button value. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#radio_group/1","title":"PrimerLive.Component.radio_group/1","type":"function"},{"doc":"Generates a single or multiple select input. Wrapper around Phoenix.HTML.Form.select/4 and Phoenix.HTML.Form.multiple_select/4 . &lt; . select name = &quot;age&quot; options = { 25 .. 35 } / &gt; Examples Options can contain: A list: 25..35 [&quot;male&quot;, &quot;female&quot;, &quot;won't say&quot;] A keyword list: [&quot;Admin&quot;: &quot;admin&quot;, &quot;User&quot;: &quot;user&quot;] A nested keyword list with option attributes: [[key: &quot;Admin&quot;, value: &quot;admin&quot;, disabled: true], [key: &quot;User&quot;, value: &quot;user&quot;]] Create a small select input: &lt; . select name = &quot;age&quot; options = { 25 .. 35 } is_small / &gt; Set the selected item: &lt; . select name = &quot;age&quot; options = { 25 .. 35 } selected = &quot;30&quot; / &gt; Add a prompt: &lt; . select name = &quot;age&quot; options = { 25 .. 35 } prompt = &quot;Choose your age&quot; / &gt; Set attributes to the prompt option: &lt; . select name = &quot;age&quot; options = { 25 .. 35 } prompt = { [ key : &quot;Choose your age&quot; , disabled : true , selected : true ] } / &gt; Create a multiple select with is_multiple . Use is_auto_height to set the height of the select input to the number of options. From the Phoenix documentation: Values are expected to be an Enumerable containing two-item tuples (like maps and keyword lists) or any Enumerable where the element will be used both as key and value for the generated select. selected should contain a list of selected options. &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . select form = { f } field = { :role } options = { [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; , &quot;Editor&quot; : &quot;editor&quot; ] } is_multiple is_auto_height selected = { [ &quot;user&quot; , &quot;tester&quot; ] } / &gt; &lt; / . form &gt; Place the select inside a form_group/1 with is_form_group . See text_input/1 for examples. A validation error message is automatically added when using a changeset with an error state. See text_input/1 how to customise the validation messages. Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. options ( :any ) (required) - List, map or keyword list. class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for select elements. Any provided value will be appended to the default classname. Default map: %{ select_container : &quot;&quot; , # Select container element select : &quot;&quot; , # Select element validation_message : &quot;&quot; , # Validation message } Defaults to %{select: nil, select_container: nil, validation_message: nil} . prompt ( :any ) - The default option that is displayed in the select options before the user makes a selection. See Phoenix.HTML.Form.multiple_select/4 . Pass a string or a keyword list. Examples: &lt; . select name = &quot;age&quot; options = { 25 .. 35 } prompt = &quot;Choose your age&quot; / &gt; Set attributes to the prompt option: &lt; . select name = &quot;age&quot; options = { 25 .. 35 } prompt = { [ key : &quot;Choose your age&quot; , disabled : true , selected : true ] } / &gt; is_multiple ( :boolean ) - Creates a multiple select. Uses Phoenix.HTML.Form.multiple_select/4 . From the Phoenix documentation: Values are expected to be an Enumerable containing two-item tuples (like maps and keyword lists) or any Enumerable where the element will be used both as key and value for the generated select. Defaults to false . is_small ( :boolean ) - Creates a small select. Defaults to false . is_large ( :boolean ) - Creates a large select. Defaults to false . is_short ( :boolean ) - Creates a short select. Defaults to false . is_shorter ( :boolean ) - Creates a shorter select. Defaults to false . is_full_width ( :boolean ) - Full width select. Defaults to false . is_auto_height ( :boolean ) - When using is_multiple : sets the size to the number of options. Defaults to false . is_monospace ( :boolean ) - Uses a monospace font. Defaults to false . is_form_group ( :boolean ) - Inserts the select inside a form_group/1 . Attributes form and field are passed to the form group to generate a group label. To configure the form group and label, use attr form_group . Defaults to false . form_group ( :any ) - Form group attributes. Inserts the select inside a form_group/1 with given attributes, alongside form and field to generate a group label. validation_message ( :any ) - Function to write a custom validation message (in case of error or success). See text_input/1 . Global attributes are accepted. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#select/1","title":"PrimerLive.Component.select/1","type":"function"},{"doc":"Generates a select menu. &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :item &gt; Item 1 &lt; / :item &gt; &lt; :item &gt; Item 2 &lt; / :item &gt; &lt; :item &gt; Item 3 &lt; / :item &gt; &lt; / . select_menu &gt; Examples When a link attribute is supplied to the item slot, links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add a dropdown caret: &lt; . select_menu is_dropdown_caret &gt; ... &lt; / . select_menu &gt; Add dividers, with or without content: &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :item &gt; Item 1 &lt; / :item &gt; &lt; :item is_divider / &gt; &lt; :item &gt; Item 2 &lt; / :item &gt; &lt; :item is_divider &gt; Divider content &lt; / :item &gt; &lt; :item &gt; Item 3 &lt; / :item &gt; &lt; / . select_menu &gt; Selected state. When any item is selected, all other items will line up nicely: &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :item is_selected &gt; Selected &lt; / :item &gt; &lt; :item &gt; Not selected &lt; / :item &gt; &lt; / . select_menu &gt; Add a menu title. The title is placed in a header row with a close button. The click target for the button is based on the id attribute (generated automatically if not supplied). &lt; . select_menu id = &quot;this-id-is-optional&quot; &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :menu title = &quot;Title&quot; / &gt; ... &lt; / . select_menu &gt; Add a message: &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :message class = &quot;color-bg-danger color-fg-danger&quot; &gt; Message &lt; / :message &gt; ... &lt; / . select_menu &gt; Add a filter input: &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :filter &gt; &lt; form &gt; &lt; . text_input class = &quot;SelectMenu-input&quot; type = &quot;search&quot; name = &quot;q&quot; placeholder = &quot;Filter&quot; / &gt; &lt; / form &gt; &lt; / :filter &gt; ... &lt; / . select_menu &gt; Add a tab menu filter by using slot tab : &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :tab is_selected &gt; Selected &lt; / :tab &gt; &lt; :tab &gt; Other tab &lt; / :tab &gt; ... &lt; / . select_menu &gt; Add a footer: &lt; . select_menu &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; ... &lt; :footer &gt; Footer &lt; / :footer &gt; &lt; / . select_menu &gt; Attributes is_dropdown_caret ( :boolean ) - Adds a dropdown caret to the button. Defaults to false . is_right_aligned ( :boolean ) - Aligns the menu to the right. Defaults to false . is_borderless ( :boolean ) - Removes the borders between list items. Defaults to false . class ( :string ) - Additional classname. classes ( :map ) - Additional classnames for select menu elements. Any provided value will be appended to the default classname, except for toggle that will override the default class &quot;btn&quot;. Default map: %{ blankslate : &quot;&quot; , # Blankslate content element. caret : &quot;&quot; , # Dropdown caret element. divider : &quot;&quot; , # Divider item element. filter : &quot;&quot; , # Filter content element footer : &quot;&quot; , # Footer element. header_close_button : &quot;&quot; , # Close button in the header. header : &quot;&quot; , # Header element. item : &quot;&quot; , # Item element. loading : &quot;&quot; , # Loading content element. menu_container : &quot;&quot; , # Menu container (called &quot;modal&quot; at PrimerCSS). menu_list : &quot;&quot; , # Menu list container. menu_title : &quot;&quot; , # Menu title. menu : &quot;&quot; , # Menu element message : &quot;&quot; , # Message element. select_menu : &quot;&quot; , # Select menu container (details element). tabs : &quot;&quot; , # Tab container. tab : &quot;&quot; , # Tab button. toggle : &quot;&quot; , # Toggle element. Any value will override the # default class &quot;btn&quot;. } Defaults to %{blankslate: nil, caret: nil, divider: nil, filter: nil, footer: nil, header: nil, header_close_button: nil, item: nil, loading: nil, menu: nil, menu_container: nil, menu_list: nil, menu_title: nil, message: nil, select_menu: nil, tab: nil, tabs: nil, toggle: nil} . is_backdrop ( :boolean ) - Generates a light backdrop background color. Defaults to false . is_dark_backdrop ( :boolean ) - Generates a darker backdrop background color. Defaults to false . is_medium_backdrop ( :boolean ) - Generates a medium backdrop background color. Defaults to false . is_light_backdrop ( :boolean ) - Generates a lighter backdrop background color (default). Defaults to false . is_fast ( :boolean ) - Generates fast fade transitions for backdrop and content. Defaults to true . Global attributes are accepted. Slots toggle (required) - Generates a toggle element (default with button appearance) using the slot content as label. Any custom class will override the default class &quot;btn&quot;. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the item element. menu - Generates a menu element. Accepts attributes: title ( :string ) - Generates a menu header with specified title. filter - Filter slot to insert a text_input/1 component that will drive a custom filter function. tab - Tab item element. If a tab slot is used, a tab navigation will be generated containing button elements. Accepts attributes: is_selected ( :boolean ) - The currently selected tab. rest ( :any ) - Additional HTML attributes added to the tab element. footer - Footer content. message - Message container. Use utility classes to further style the message. Example: &lt; :message class = &quot;color-bg-danger color-fg-danger&quot; &gt; Message &lt; / :message &gt; loading - Slot to show a loading animation. Example: &lt; :loading &gt; &lt; . octicon name = &quot;copilot-48&quot; class = &quot;anim-pulse&quot; / &gt; &lt; / :loading &gt; blankslate - Slot to show blankslate content. item - Menu item content. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_selected ( :boolean ) - Shows the selected state with a checkmark. is_disabled ( :boolean ) - Generates a disabled state. is_divider ( :boolean ) - Generates a divider. The divider may have content, for example a label &quot;More options&quot;. selected_octicon_name ( :boolean ) - The icon name for the selected state, for example &quot;check-circle-fill-16&quot;. Default &quot;check-16&quot;. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. Reference Primer/CSS Select menu Status Feature complete.","ref":"PrimerLive.Component.html#select_menu/1","title":"PrimerLive.Component.select_menu/1","type":"function"},{"doc":"Generates a vertical list of navigational links. Menu items are rendered as link element. &lt; . side_nav aria_label = &quot;Site navigation&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Account &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Emails &lt; / :item &gt; &lt; / . side_nav &gt; Examples Menu links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add other types of content, such as icons and counters: &lt; . side_nav &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; &lt; . octicon name = &quot;comment-discussion-16&quot; / &gt; &lt; span &gt; Conversation &lt; / span &gt; &lt; . counter &gt; 2 &lt; / . counter &gt; &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; &lt; . octicon name = &quot;check-circle-16&quot; / &gt; &lt; span &gt; Done &lt; / span &gt; &lt; . counter &gt; 99 &lt; / . counter &gt; &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; &lt; h5 &gt; With a heading &lt; / h5 &gt; &lt; span &gt; and some longer description &lt; / span &gt; &lt; / :item &gt; &lt; / . side_nav &gt; Add a border (not for sub navigation): &lt; . side_nav is_border &gt; ... &lt; / . side_nav &gt; Create a sub navigation: a lightweight version without borders and more condensed. &lt; . side_nav is_sub_nav &gt; ... &lt; / . side_nav &gt; A sub navigation can be placed inside a side navigation, using an item slot without attributes: &lt; . side_nav is_border &gt; &lt; :item href = &quot;#url&quot; &gt; Item 1 &lt; / :item &gt; &lt; :item navigate = &quot;#url&quot; is_selected &gt; Item 2 &lt; / :item &gt; &lt; :item &gt; &lt; . side_nav is_sub_nav class = &quot;border-top py-3&quot; style = &quot;padding-left: 16px&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Sub item 1 &lt; / :item &gt; &lt; :item navigate = &quot;#url&quot; &gt; Sub item 2 &lt; / :item &gt; &lt; / . side_nav &gt; &lt; / :item &gt; &lt; :item navigate = &quot;#url&quot; &gt; Item 3 &lt; / :item &gt; &lt; / . side_nav &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for underline nav elements. Any provided value will be appended to the default classname. Default map: %{ side_nav : &quot;&quot; , # Outer container (nav element) item : &quot;&quot; , # Menu item element sub_item : &quot;&quot; , # Menu sub item element } Defaults to %{item: nil, side_nav: nil, sub_item: nil} . aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . is_border ( :boolean ) - Adds a border. Not applied when using is_sub_nav . Defaults to false . is_sub_nav ( :boolean ) - Sets the menu style to &quot;sub navigation&quot;: a lightweight version without borders and more condensed. Defaults to false . Global attributes are accepted. Slots item (required) - Menu content. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_selected ( :boolean ) - Shows the selected state. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. Reference Primer/CSS Navigation Status Feature complete.","ref":"PrimerLive.Component.html#side_nav/1","title":"PrimerLive.Component.side_nav/1","type":"function"},{"doc":"SVG spinner animation. This spinner is derived from the Toast loading animation. &lt; . spinner / &gt; Alternatively, use octicon/1 with class &quot;Toast--spinner&quot;, using any circular icon: &lt; . octicon name = &quot;skip-16&quot; class = &quot;Toast--spinner&quot; / &gt; Examples Set the size (default: 18 ): &lt; . spinner size = &quot;40&quot; / &gt; Set the circle color (default: #959da5 ): &lt; . spinner color = &quot;red&quot; / &gt; &lt; . spinner color = &quot;#ff0000&quot; / &gt; &lt; . spinner color = &quot;rgba(250, 50, 150, 0.5)&quot; / &gt; Set the gap color (default: #ffffff ): &lt; . spinner gap_color = &quot;black&quot; / &gt; &lt; . spinner gap_color = &quot;#000000&quot; / &gt; &lt; . spinner gap_color = &quot;rgba(0, 0, 0, 1)&quot; / &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . size ( :integer ) - Spinner size. Defaults to 18 . color ( :string ) - Spinner color as SVG fill color. Defaults to &quot;#959da5&quot; . gap_color ( :string ) - Spinner gap color as SVG fill color. Defaults to &quot;#ffffff&quot; . Global attributes are accepted.","ref":"PrimerLive.Component.html#spinner/1","title":"PrimerLive.Component.spinner/1","type":"function"},{"doc":"Shows an item's status. State labels are larger and styled with bolded text. Attribute settings allows to apply colors. &lt; . state_label &gt; Label &lt; / . state_label &gt; Examples Set a state (applying a background color): &lt; . state_label is_open &gt; Label &lt; / . state_label &gt; Smaller label: &lt; . state_label is_small &gt; Label &lt; / . state_label &gt; With an icon: &lt; . state_label is_open &gt; &lt; . octicon name = &quot;git-pull-request-16&quot; / &gt; Label &lt; / . state_label &gt; Attributes class ( :string ) - Additional classname. is_draft ( :boolean ) - Draft state color. Defaults to false . is_open ( :boolean ) - Open state color. Defaults to false . is_merged ( :boolean ) - Merged state color. Defaults to false . is_closed ( :boolean ) - Closed state color. Defaults to false . is_small ( :boolean ) - Smaller state label. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Label content. Reference Primer/CSS Labels Status Feature complete.","ref":"PrimerLive.Component.html#state_label/1","title":"PrimerLive.Component.state_label/1","type":"function"},{"doc":"Adds styling to HTML. This can be used to format HTML generated by a Markdown library, or to create consistent layout of HTML content. &lt; . styled_html &gt; Content &lt; / . styled_html &gt; Attributes class ( :string ) - Additional classname. Global attributes are accepted. Slots inner_block (required) - Content to be formatted. Reference Primer/CSS Markdown Status Feature complete.","ref":"PrimerLive.Component.html#styled_html/1","title":"PrimerLive.Component.styled_html/1","type":"function"},{"doc":"Configurable and styled h2 heading. &lt; / . subhead &gt; Plain subhead &lt; / . subhead &gt; Examples Add a top margin when separating sections on a settings page: &lt; / . subhead is_spacious &gt; Subhead &lt; / . subhead &gt; Create a danger zone heading: &lt; / . subhead is_danger &gt; Plain subhead &lt; / . subhead &gt; Add a description: &lt; . subhead &gt; Heading &lt; :description &gt; Description &lt; / :description &gt; &lt; / . subhead &gt; Add an action (button or link): &lt; . subhead &gt; Heading &lt; :actions &gt; &lt; . button is_primary &gt; Action &lt; / . button &gt; &lt; / :actions &gt; &lt; / . subhead &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for subhead elements. Any provided value will be appended to the default classname. Default map: %{ subhead : &quot;&quot; , # Subhead container heading : &quot;&quot; , # h2 heading description : &quot;&quot; , # Description element actions : &quot;&quot; , # Actions section element } Defaults to %{actions: nil, description: nil, heading: nil, subhead: nil} . is_spacious ( :boolean ) - Add a top margin. Defaults to false . is_danger ( :boolean ) - Makes the text bold and red. This is useful for warning users. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Heading content. description - Description content. actions - Actions content. Reference Primer/CSS Subhead Status Feature complete.","ref":"PrimerLive.Component.html#subhead/1","title":"PrimerLive.Component.subhead/1","type":"function"},{"doc":"Subnav is navigation that is typically used when on a dashboard type interface with another set of navigation above it. This helps distinguish navigation hierarchy Subnav is composed of one or more child components: subnav_links/1 - a link row subnav_search/1 - a search field subnav_search_context/1 - a search filter menu adjacent to the search field Minimal version, showing the link row: &lt; . subnav &gt; &lt; . subnav_links &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Item 1 &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Item 2 &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Item 3 &lt; / :item &gt; &lt; / . subnav_links &gt; &lt; / . subnav &gt; Examples subnav_links To show a link row, use child component subnav_links/1 . Navigation links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; subnav_search To add a search field, use child component subnav_search/1 with a text_input/1 component. Use type=&quot;search&quot; to display a search icon inside the search field. &lt; . subnav &gt; &lt; . subnav_search &gt; &lt; . text_input type = &quot;search&quot; / &gt; &lt; / . subnav_search &gt; &lt; / . subnav &gt; subnav_search_context To place a filter menu adjacent to the search field, use child component subnav_search_context/1 with a select_menu/1 component: &lt; . subnav &gt; &lt; . subnav_search_context &gt; &lt; . select_menu is_dropdown_caret &gt; &lt; :toggle &gt; Menu &lt; / :toggle &gt; &lt; :item &gt; Item 1 &lt; / :item &gt; &lt; :item &gt; Item 2 &lt; / :item &gt; &lt; :item &gt; Item 3 &lt; / :item &gt; &lt; / . select_menu &gt; &lt; / . subnav_search_context &gt; &lt; . subnav_search &gt; &lt; . text_input type = &quot;search&quot; / &gt; &lt; / . subnav_search &gt; &lt; / . subnav &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . is_wrap ( :boolean ) - Allows child elements to wrap, for example a link row followed by a search field. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Subnav components. Reference Primer/CSS Navigation Status Feature complete.","ref":"PrimerLive.Component.html#subnav/1","title":"PrimerLive.Component.subnav/1","type":"function"},{"doc":"Subnav link row. See subnav/1 . Attributes aria_label ( :string ) - Adds attribute aria-label to the subnav links element. Defaults to nil . class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for subnav links elements. Any provided value will be appended to the default classname. Default map: %{ subnav_links : &quot;&quot; , # Outer container (nav element) item : &quot;&quot; , # Link item element } Defaults to %{item: nil, subnav_links: nil} . Global attributes are accepted. Slots item (required) - Subnav buttons item. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_selected ( :boolean ) - Shows the selected state. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element.","ref":"PrimerLive.Component.html#subnav_links/1","title":"PrimerLive.Component.subnav_links/1","type":"function"},{"doc":"Subnav search field. See subnav/1 . Attributes class ( :string ) - Additional classname. Defaults to nil . Global attributes are accepted. Slots inner_block (required) - Contents.","ref":"PrimerLive.Component.html#subnav_search/1","title":"PrimerLive.Component.subnav_search/1","type":"function"},{"doc":"Subnav search filter adjacent to the search field. See subnav/1 . Attributes class ( :string ) - Additional classname. Defaults to nil . Global attributes are accepted. Slots inner_block (required) - Contents.","ref":"PrimerLive.Component.html#subnav_search_context/1","title":"PrimerLive.Component.subnav_search_context/1","type":"function"},{"doc":"Generates a tab navigation. Tabs are by default rendered as buttons. To create link elements, pass attribute href , navigate or patch . &lt; . tabnav aria_label = &quot;Topics navigation&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Link tab &lt; / :item &gt; &lt; :item &gt; Button tab &lt; / :item &gt; &lt; / . tabnav &gt; Examples When a link attribute is supplied to the item slot, links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add other types of content, such as icons and counters: &lt; . tabnav &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; &lt; . octicon name = &quot;comment-discussion-16&quot; / &gt; &lt; span &gt; Conversation &lt; / span &gt; &lt; . counter &gt; 2 &lt; / . counter &gt; &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; &lt; . octicon name = &quot;check-circle-16&quot; / &gt; &lt; span &gt; Done &lt; / span &gt; &lt; . counter &gt; 99 &lt; / . counter &gt; &lt; / :item &gt; &lt; / . tabnav &gt; Position additional content to the far end of the tabs. A button placed at the far end: &lt; . tabnav &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; One &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Two &lt; / :item &gt; &lt; :position_end &gt; &lt; a class = &quot;btn btn-sm&quot; href = &quot;#url&quot; role = &quot;button&quot; &gt; Button &lt; / a &gt; &lt; / :position_end &gt; &lt; / . tabnav &gt; Extra content (not a button) is styled using attribute is_extra : &lt; . tabnav &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; One &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Two &lt; / :item &gt; &lt; :position_end is_extra &gt; Tabnav widget text here . &lt; / :position_end &gt; &lt; / . tabnav &gt; Create small tabs (similar to tabs inside a select_menu/1 ) with is_small : &lt; . tabnav &gt; &lt; :item is_small is_selected &gt; One &lt; / :item &gt; &lt; :item is_small &gt; Two &lt; / :item &gt; &lt; / . tabnav &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for tabnav elements. Any provided value will be appended to the default classname. Default map: %{ tabnav : &quot;&quot; , # Outer container nav : &quot;&quot; , # Nav element tab : &quot;&quot; , # Tab link element position_end : &quot;&quot; , # Container for elements positions at the far end } Defaults to %{nav: nil, position_end: nil, tab: nil, tabnav: nil} . aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . Global attributes are accepted. Slots item (required) - Tab item content. Tabs are by default rendered as buttons. To create a link element, pass attribute href , navigate or patch . Accepts attributes: is_selected ( :boolean ) - Shows the selected state. is_small ( :boolean ) - Creates a small tab, similar to tabs inside a select_menu/1 . href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. position_end - Container for elements positions at the far end. Accepts attributes: is_extra ( :boolean ) - Adds styles to optimise additional bits of text and links. rest ( :any ) - Additional HTML attributes added to the far end container. Reference Primer/CSS Navigation Status Feature complete.","ref":"PrimerLive.Component.html#tabnav/1","title":"PrimerLive.Component.tabnav/1","type":"function"},{"doc":"Generates a text input field. Wrapper around Phoenix.HTML.Form.text_input/3 , optionally wrapped itself inside a &quot;form group&quot; to add a field label. &lt; . text_input field = &quot;first_name&quot; / &gt; Examples Set the input type: &lt; . text_input type = &quot;password&quot; / &gt; &lt; . text_input type = &quot;hidden&quot; / &gt; &lt; . text_input type = &quot;email&quot; / &gt; Set the placeholder. By default, the value of the placeholder attribute is used to fill in the aria-label attribute: &lt; . text_input placeholder = &quot;Enter your first name&quot; / &gt; Using the input with form data: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . text_input form = { f } field = { :first_name } / &gt; &lt; . text_input form = { f } field = { :last_name } / &gt; &lt; / . form &gt; Attach a button to the input with slot group_button : &lt; . text_input &gt; &lt; :group_button &gt; &lt; . button &gt; Send &lt; / . button &gt; &lt; / :group_button &gt; &lt; / . text_input &gt; or use an icon button: &lt; . text_input &gt; &lt; :group_button &gt; &lt; . button aria - label = &quot;Copy&quot; &gt; &lt; . octicon name = &quot;paste-16&quot; / &gt; &lt; / . button &gt; &lt; / :group_button &gt; &lt; / . text_input &gt; Add a button to the text input with slot trailing_action : &lt; . text_input &gt; &lt; :trailing_action &gt; &lt; . button is_icon_only aria - label = &quot;Clear&quot; &gt; &lt; . octicon name = &quot;x-16&quot; / &gt; &lt; / . button &gt; &lt; / :trailing_action &gt; &lt; / . text_input &gt; Only show the trailing action when the input has a value: &lt; . text_input &gt; &lt; :trailing_action is_visible_with_value &gt; &lt; . button is_icon_only aria - label = &quot;Clear&quot; &gt; &lt; . octicon name = &quot;x-16&quot; / &gt; &lt; / . button &gt; &lt; / :trailing_action &gt; &lt; / . text_input &gt; Add a leading visual with slot leading_visual : &lt; . text_input &gt; &lt; :leading_visual &gt; &lt; . octicon name = &quot;mail-16&quot; / &gt; &lt; / :leading_visual &gt; &lt; / . text_input &gt; Place the input inside a form_group/1 with is_form_group . Attributes form and field are passed to the form group to generate a group label. &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . text_input form = { f } field = { :first_name } is_form_group / &gt; &lt; / . form &gt; To configure the form group and label, use attr form_group . See form_group/1 for supported attributes. A validation error message is automatically added when using a changeset with an error state. The message text is taken from the changeset errors. To show a custom validation error message, supply function validation_message : &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . text_input form = { f } field = { :first_name } form_group = { %{ label : &quot;Custom label&quot; , validation_message : fn field_state -&gt; if ! field_state . valid? , do : &quot;Please enter your first name&quot; end } } / &gt; &lt; / . form &gt; Similarly, to show a custom validation success message: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . text_input form = { f } field = { :first_name } validation_message = { fn field_state -&gt; if field_state . valid? , do : &quot;Available!&quot; end } / &gt; &lt; / . form &gt; Attributes field ( :any ) - Field name (atom or string). form ( :any ) - Either a Phoenix.HTML.Form or an atom. class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for input elements. Any provided value will be appended to the default classname. Default map: %{ input : &quot;&quot; , # Input element input_group : &quot;&quot; , # Wrapper around the grouped input and group button input_group_button : &quot;&quot; , # Wrapper around slot group_button validation_message : &quot;&quot; , # Validation message input_wrap : &quot;&quot; , # Input wrapper when leading or trailing visual is used } Defaults to %{input: nil, input_group: nil, input_group_button: nil, input_wrap: nil, validation_message: nil} . type ( :string ) - Text input type. Defaults to &quot;text&quot; . is_contrast ( :boolean ) - Changes the background color to light gray. Defaults to false . is_full_width ( :boolean ) - Full width input. Defaults to false . is_hide_webkit_autofill ( :boolean ) - Hide WebKit's contact info autofill icon. Defaults to false . is_large ( :boolean ) - Additional padding creates a higher input box. If no width is specified, the input box is slightly wider. Defaults to false . is_small ( :boolean ) - Smaller (less high) input with smaller text size. Defaults to false . is_short ( :boolean ) - Inside a form group. Generates an input with a reduced width. Defaults to false . is_shorter ( :boolean ) - Inside a form group. Generates an input with a even more reduced width. Defaults to false . is_monospace ( :boolean ) - Uses a monospace font. Defaults to false . is_form_group ( :boolean ) - Inserts the input inside a form_group/1 . Attributes form and field are passed to the form group to generate a group label. To configure the form group and label, use attr form_group . Defaults to false . form_group ( :any ) - Form group attributes. Inserts the input inside a form_group/1 with given attributes, alongside form and field to generate a group label. validation_message ( :any ) - Function to write a custom validation message (in case of error or success). The function receives a PrimerLive.FieldState struct and returns a validation message. A validation message is shown: If form is a Phoenix.HTML.Form , containing a changeset And either: changeset.action is :validate validation_message returns a string Function signature: fun field_state -&gt; string | nil . Example error message: fn field_state -&gt; if ! field_state . valid? , do : &quot;Please enter your first name&quot; end Example success message, only shown when changeset.action is :validate : fn field_state -&gt; if field_state . valid? &amp;&amp; field_state . changeset . action == :validate , do : &quot;Is available&quot; end Global attributes are accepted. Slots group_button - Primer CSS &quot;Input group&quot;. Attaches a button at the end of the input. Example: &lt; . text_input &gt; &lt; :group_button &gt; &lt; . button aria - label = &quot;Copy&quot; &gt; &lt; . octicon name = &quot;paste-16&quot; / &gt; &lt; / . button &gt; &lt; / :group_button &gt; &lt; / . text_input &gt; leading_visual - Container for a leading visual. Commonly a octicon/1 component is used. trailing_action - Container for a trailing action. Commonly a octicon/1 component, or a button/1 component with an icon (no label) is used. Accepts attributes: is_divider ( :boolean ) - Adds a separator line. is_visible_with_value ( :boolean ) - Only show the trailing action when the input has a value. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#text_input/1","title":"PrimerLive.Component.text_input/1","type":"function"},{"doc":"Generates a textarea. &lt; . textarea name = &quot;comments&quot; / &gt; Attributes Use text_input/1 attributes. Reference Primer/CSS Forms Status Feature complete.","ref":"PrimerLive.Component.html#textarea/1","title":"PrimerLive.Component.textarea/1","type":"function"},{"doc":"Creates a wrapper that sets the light/dark color mode and theme, with support for color blindness. See also PrimerLive.Theme . Alternative method Instead of using a wrapper, consider using Theme.html_attributes to set a theme on a component or element directly: &lt; . button { PrimerLive.Theme . html_attributes ( [ color_mode : &quot;dark&quot; , dark_theme : &quot;dark_high_contrast&quot; ] ) } &gt; Button &lt; / . button &gt; &lt; . octicon name = &quot;sun-24&quot; { PrimerLive.Theme . html_attributes ( %{ color_mode : &quot;dark&quot; , dark_theme : &quot;dark_dimmed&quot; } ) } / &gt; Theme wrapper examples Use default settings: &lt; . theme &gt; Content &lt; / . theme &gt; Set the color mode to dark and specify the dark theme: &lt; . theme color_mode = &quot;dark&quot; dark_theme = &quot;dark_dimmed&quot; &gt; Content &lt; / . theme &gt; Specify light and dark themes: &lt; . theme color_mode = &quot;dark&quot; light_theme = &quot;light_high_contrast&quot; dark_theme = &quot;dark_high_contrast&quot; &gt; Content &lt; / . theme &gt; Use a theme_state struct for easier passing around state: assigns = assign |&gt; assign ( :theme_state , %{ color_mode : &quot;light&quot; , light_theme : &quot;light_high_contrast&quot; , dark_theme : &quot;dark_high_contrast&quot; } ) &lt; . theme theme_state = { @theme_state } &gt; Content &lt; / . theme &gt; Attributes theme_state ( :map ) - Sets all theme values at once. Defaults to nil . color_mode ( :string ) - Color mode. Defaults to &quot;auto&quot; . light_theme ( :string ) - Light theme. Possible values: &quot;light&quot; &quot;light_high_contrast&quot; &quot;light_colorblind&quot; &quot;light_tritanopia&quot; Defaults to &quot;light&quot; . dark_theme ( :string ) - Dark theme. Possible values: &quot;dark&quot; &quot;dark_dimmed&quot; &quot;dark_high_contrast&quot; &quot;dark_colorblind&quot; &quot;dark_tritanopia&quot; Defaults to &quot;dark&quot; . is_inline ( :boolean ) - Renders the wrapper as a span . Useful for setting the color on an inline element. Defaults to false . Global attributes are accepted. Slots inner_block (required) - Content. Reference Primer/CSS Theming Status Feature complete.","ref":"PrimerLive.Component.html#theme/1","title":"PrimerLive.Component.theme/1","type":"function"},{"doc":"Generates theme menu options as an action_list/1 , to be used inside an action_menu/1 . See also PrimerLive.Theme . Menu options To create a default menu - showing all possible options, using default labels: &lt; . theme_menu_options theme_state = { @theme_state } default_theme_state = { @default_theme_state } / &gt; theme_state contains the current theme state default_theme_state contains the initial (default) state Menu Place the menu options inside an expanding menu: &lt; . action_menu &gt; &lt; :toggle class = &quot;btn btn-invisible&quot; &gt; &lt; . octicon name = &quot;sun-16&quot; / &gt; &lt; / :toggle &gt; &lt; . theme_menu_options theme_state = { @theme_state } / &gt; &lt; / . action_menu &gt; To make the selected theme persist, follow the instructions in PrimerLive.Theme . Attributes default_theme_state ( :map ) - Defines the default (and initial) theme state. Pass a map with all theme state keys. Change the values to meet specific use cases, for example to set a light color mode instead of &quot;auto&quot;: %{ color_mode : &quot;light&quot; , light_theme : &quot;light&quot; , dark_theme : &quot;dark_dimmed&quot; } Defaults to %{color_mode: &quot;auto&quot;, dark_theme: &quot;dark&quot;, light_theme: &quot;light&quot;} . theme_state ( :map ) (required) - Defines the current theme state. When using persistent data, this will be passed from the session. Pass a map with all theme state keys. For example: %{ color_mode : &quot;light&quot; , light_theme : &quot;light_high_contrast&quot; , dark_theme : &quot;dark_high_contrast&quot; } options ( :map ) - Selectable options (keys). To show a limited set of theme options: %{ color_mode : ~w(light dark) , light_theme : ~w(light light_high_contrast) , dark_theme : ~w(dark dark_dimmed) } or even: %{ color_mode : ~w(light dark) } Defaults to %{color_mode: [&quot;light&quot;, &quot;dark&quot;, &quot;auto&quot;], dark_theme: [&quot;dark&quot;, &quot;dark_dimmed&quot;, &quot;dark_high_contrast&quot;, &quot;dark_colorblind&quot;, &quot;dark_tritanopia&quot;], light_theme: [&quot;light&quot;, &quot;light_high_contrast&quot;, &quot;light_colorblind&quot;, &quot;light_tritanopia&quot;]} . labels ( :map ) - Custom labels for menu items. For example: %{ color_mode : %{ light : &quot;Light theme&quot; } , reset : &quot;Reset&quot; } Defaults to %{color_mode: %{auto: &quot;System&quot;, dark: &quot;Dark&quot;, light: &quot;Light&quot;, title: &quot;Theme&quot;}, dark_theme: %{dark: &quot;Dark&quot;, dark_colorblind: &quot;Dark colorblind&quot;, dark_dimmed: &quot;Dark dimmed&quot;, dark_high_contrast: &quot;Dark high contrast&quot;, dark_tritanopia: &quot;Dark Tritanopia&quot;, title: &quot;Dark tone&quot;}, light_theme: %{light: &quot;Light&quot;, light_colorblind: &quot;Light colorblind&quot;, light_high_contrast: &quot;Light high contrast&quot;, light_tritanopia: &quot;Light Tritanopia&quot;, title: &quot;Light tone&quot;}, reset: &quot;Reset to default&quot;} . is_show_group_labels ( :boolean ) - Set to false to remove the labels above the menu groups. Defaults to true . is_show_reset_link ( :boolean ) - Set to false to remove the reset link. Defaults to true . is_click_disabled ( :boolean ) - For demo purposes. Set to true to prevent clicks on options. Defaults to false . Global attributes are accepted.","ref":"PrimerLive.Component.html#theme_menu_options/1","title":"PrimerLive.Component.theme_menu_options/1","type":"function"},{"doc":"Generates a timeline item to display items on a vertical timeline. &lt; . timeline_item &gt; &lt; :badge &gt; &lt; . octicon name = &quot;flame-16&quot; / &gt; &lt; / :badge &gt; Everything is fine &lt; / . timeline_item &gt; Examples Add color to the badge by using attribute state . Possible states: &quot;default&quot; - light gray &quot;info&quot; - blue &quot;success&quot; - green &quot;warning&quot; - ocher &quot;error&quot; - red &lt; . timeline_item state = &quot;error&quot; &gt; &lt; :badge &gt; &lt; . octicon name = &quot;flame-16&quot; / &gt; &lt; / :badge &gt; Everything will be fine &lt; / . timeline_item &gt; Alternatively, use Primer CSS modifier classes on the badge slot to assign colors: &lt; . timeline_item &gt; &lt; :badge class = &quot;color-bg-done-emphasis color-fg-on-emphasis&quot; &gt; &lt; . octicon name = &quot;flame-16&quot; / &gt; &lt; / :badge &gt; Everything will be fine &lt; / . timeline_item &gt; When a link attribute is supplied to the badge slot, links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :badge href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :badge navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :badge patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Create a condensed item, reducing the vertical padding and removing the background from the badge item: &lt; . timeline_item is_condensed &gt; &lt; :badge &gt; &lt; . octicon name = &quot;git-commit-16&quot; / &gt; &lt; / :badge &gt; My commit &lt; / . timeline_item &gt; Display an avatar of the author: &lt; . timeline_item &gt; &lt; :badge &gt; &lt; . octicon name = &quot;git-commit-16&quot; / &gt; &lt; / :badge &gt; &lt; :avatar &gt; &lt; . avatar size = &quot;6&quot; src = &quot;user.jpg&quot; / &gt; &lt; / :avatar &gt; Someone &#39; s commit &lt; / . timeline_item &gt; Create a visual break in the timeline with attribute is_break . This adds a horizontal bar across the timeline to show that something has disrupted it. &lt; . timeline_item state = &quot;error&quot; &gt; &lt; :badge &gt; &lt; . octicon name = &quot;flame-16&quot; / &gt; &lt; / :badge &gt; Everything will be fine &lt; / . timeline_item &gt; &lt; . timeline_item is_break / &gt; &lt; . timeline_item state = &quot;success&quot; &gt; &lt; :badge &gt; &lt; . octicon name = &quot;smiley-16&quot; / &gt; &lt; / :badge &gt; Everything is fine &lt; / . timeline_item &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for timeline elements. Any provided value will be appended to the default classname. Default map: %{ timeline_item : &quot;&quot; , # Outer container badge : &quot;&quot; , # Badge element avatar : &quot;&quot; , # Avatar container body : &quot;&quot; , # Body element state_default : &quot;&quot; , # Badge color modifier state_info : &quot;&quot; , # Badge color modifier state_success : &quot;&quot; , # Badge color modifier state_warning : &quot;&quot; , # Badge color modifier state_error : &quot;&quot; , # Badge color modifier } Defaults to %{avatar: nil, badge: nil, body: nil, state_default: nil, state_error: nil, state_info: nil, state_success: nil, state_warning: nil, timeline_item: nil} . state ( :string ) - Create a badge color variant by setting the state. Color mapping: &quot;default&quot; - light gray &quot;info&quot; - blue &quot;success&quot; - green &quot;warning&quot; - ocher &quot;error&quot; - red Must be one of &quot;default&quot; , &quot;info&quot; , &quot;success&quot; , &quot;warning&quot; , or &quot;error&quot; . is_condensed ( :boolean ) - Creates a condensed item, reducing the vertical padding and removing the background from the badge item. Defaults to false . is_break ( :boolean ) - Creates a visual break in the timeline. This adds a horizontal bar across the timeline to show that something has disrupted it. Ignores any slots. Defaults to false . Global attributes are accepted. Slots badge - Badge content. Pass an octicon/1 to display an icon. To create a link element, pass attribute href , navigate or patch . Accepts attributes: href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the badge element. avatar - Avatar container. inner_block - Item body. Reference Primer/CSS Timeline Status Feature complete.","ref":"PrimerLive.Component.html#timeline_item/1","title":"PrimerLive.Component.timeline_item/1","type":"function"},{"doc":"Shortens text with ellipsis. &lt; . truncate &gt; &lt; :item &gt; really - long - text &lt; / :item &gt; &lt; / . truncate &gt; Examples Change the default generated HTML tags (default &quot;span&quot;). Note that the outer element is by default styled as inline-flex , regardless of the provided tag. &lt; . truncate tag = &quot;ol&quot; &gt; &lt; :item tag = &quot;li&quot; &gt; really - long - text &lt; / :item &gt; &lt; :item tag = &quot;li&quot; &gt; really - long - text &lt; / :item &gt; &lt; / . truncate &gt; Tabs are by default rendered as span elements. To create link elements, pass attribute href , navigate or patch . Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Multiple item texts will truncate evenly. &lt; . truncate &gt; &lt; :item &gt; really - long - text &lt; / :item &gt; &lt; :item &gt; really - long - text &lt; / :item &gt; &lt; / . truncate &gt; Delay the truncating of specific items: &lt; . truncate &gt; &lt; :item &gt; really - long - user - nametext &lt; / :item &gt; &lt; :item is_primary &gt; really - long - project - name &lt; / :item &gt; &lt; / . truncate &gt; Expand the items on hover and focus : &lt; . truncate &gt; &lt; :item expandable &gt; really - long - text &lt; / :item &gt; &lt; :item expandable &gt; really - long - text &lt; / :item &gt; &lt; / . truncate &gt; Limit the maximum width by adding max-width style: &lt; . truncate &gt; &lt; :item is_expandable style = &quot;max-width: 300px;&quot; &gt; really - long - text &lt; / :item &gt; &lt; / . truncate &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for truncate elements. Any provided value will be appended to the default classname. Default map: %{ truncate : &quot;&quot; , # Truncate wrapper element item : &quot;&quot; , # Text wrapper element } Defaults to %{item: nil, truncate: nil} . tag ( :string ) - HTML tag used for the truncate wrapper. Defaults to &quot;span&quot; . Global attributes are accepted. Slots item (required) - Wrapper around text to be truncated. Accepts attributes: tag ( :string ) - HTML tag used for the text wrapper. Default: &quot;span&quot;. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . is_primary ( :boolean ) - When using multiple items. Delays the truncating of the item. is_expandable ( :boolean ) - When using multiple items. Will expand the text on hover and focus . rest ( :any ) - Attributes supplied to the item. Reference Primer/CSS Truncate Status Feature complete.","ref":"PrimerLive.Component.html#truncate/1","title":"PrimerLive.Component.truncate/1","type":"function"},{"doc":"Renders an interface icon. These icons, while not part of the octicon/1 icons, are used in interface elements. &lt; . ui_icon name = &quot;single-select-16&quot; / &gt; &lt; . ui_icon name = &quot;multiple-select-16&quot; / &gt; &lt; . ui_icon name = &quot;collapse-16&quot; / &gt; Attributes name ( :string ) (required) - Icon name, e.g. &quot;single-select-16&quot;. Global attributes are accepted.","ref":"PrimerLive.Component.html#ui_icon/1","title":"PrimerLive.Component.ui_icon/1","type":"function"},{"doc":"Generates a tab navigation with minimal underlined selected state, typically used for navigation placed at the top of the page. Tabs are by default rendered as buttons. To create link elements, pass attribute href , navigate or patch . &lt; . underline_nav aria_label = &quot;Site navigation&quot; &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; Link tab &lt; / :item &gt; &lt; :item &gt; Button tab &lt; / :item &gt; &lt; / . underline_nav &gt; Examples When a link attribute is supplied to the item slot, links are created with Phoenix.Component.link/1 , passing all other slot attributes to the link. Link examples: &lt; :item href = &quot;#url&quot; &gt; href link &lt; / :item &gt; &lt; :item navigate = { Routes . page_path ( @socket , :index ) } &gt; navigate link &lt; / :item &gt; &lt; :item patch = { Routes . page_path ( @socket , :index ) } &gt; patch link &lt; / :item &gt; Add other types of content, such as icons and counters: &lt; . underline_nav &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; &lt; . octicon name = &quot;comment-discussion-16&quot; / &gt; &lt; span &gt; Conversation &lt; / span &gt; &lt; . counter &gt; 2 &lt; / . counter &gt; &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; &lt; . octicon name = &quot;check-circle-16&quot; / &gt; &lt; span &gt; Done &lt; / span &gt; &lt; . counter &gt; 99 &lt; / . counter &gt; &lt; / :item &gt; &lt; / . underline_nav &gt; Position additional content to the far end of the tabs. A button placed at the far end: &lt; . underline_nav &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; One &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Two &lt; / :item &gt; &lt; :position_end &gt; &lt; a class = &quot;btn btn-sm&quot; href = &quot;#url&quot; role = &quot;button&quot; &gt; Button &lt; / a &gt; &lt; / :position_end &gt; &lt; / . underline_nav &gt; Use is_container_width in combination with container styles to make navigation fill the width of the container: &lt; . underline_nav is_container_width classes = { %{ container : &quot;container-sm&quot; } } &gt; &lt; :item href = &quot;#url&quot; is_selected &gt; One &lt; / :item &gt; &lt; :item href = &quot;#url&quot; &gt; Two &lt; / :item &gt; &lt; :position_end &gt; &lt; a class = &quot;btn btn-sm&quot; href = &quot;#url&quot; role = &quot;button&quot; &gt; Button &lt; / a &gt; &lt; / :position_end &gt; &lt; / . underline_nav &gt; Attributes class ( :string ) - Additional classname. Defaults to nil . classes ( :map ) - Additional classnames for underline nav elements. Any provided value will be appended to the default classname. Default map: %{ underline_nav : &quot;&quot; , # Outer container (nav element) container : &quot;&quot; , # Extra container wrapper when using attr is_container_width body : &quot;&quot; , # Tabs wrapper tab : &quot;&quot; , # Tab link element position_end : &quot;&quot; , # Container for elements positions at the far end } Defaults to %{body: nil, container: nil, position_end: nil, tab: nil, underline_nav: nil} . is_container_width ( :boolean ) - Use in combination with container styles to make navigation fill the width of the container. For example: &lt; . underline_nav is_container_width classes = { %{ container : &quot;container-sm&quot; } } &gt; ... &lt; / . underline_nav &gt; Defaults to false . is_reversed ( :boolean ) - In left-to-right views the navigation will be positioned at the right. Defaults to false . aria_label ( :string ) - Adds attribute aria-label to the outer element. Defaults to nil . Global attributes are accepted. Slots item (required) - Tab item content: either a link or a button.Tab item content. Tabs are by default rendered as buttons. To create a link element, pass attribute href , navigate or patch .Accepts attributes: is_selected ( :boolean ) - Shows the selected state. href ( :any ) - Link attribute. The link is created with Phoenix.Component.link/1 , passing all other slot attributes to the link. patch ( :string ) - Link attribute - see href . navigate ( :string ) - Link attribute - see href . rest ( :any ) - Additional HTML attributes added to the item element. position_end - Container for elements positions at the far end. Accepts attributes: rest ( :any ) - Additional HTML attributes added to the far end container. Reference Primer/CSS Navigation Status Feature complete.","ref":"PrimerLive.Component.html#underline_nav/1","title":"PrimerLive.Component.underline_nav/1","type":"function"},{"doc":"State object with validation data for a particular form field. Struct fields: changeset - Ecto.Changeset struct. field_errors - Changeset errors , filtered for the field. valid? - True if changeset's field_errors is empty for the field. ignore_errors? - Changeset has errors but should not be displayed (currently when changeset.action is nil ) message - Default message derived from changeset errors , unless overridden by validation_message attribute. message_id - Generated id that is used for aria_describedby .","ref":"PrimerLive.FieldState.html","title":"PrimerLive.FieldState","type":"module"},{"doc":"","ref":"PrimerLive.Octicons.html","title":"PrimerLive.Octicons","type":"module"},{"doc":"Internal use: generates a map of SVG's. To use the PrimerLive.Component.octicon/1 component, write: &lt; . octicon name = &quot;icon-name&quot; / &gt; All octicons &lt; . octicon name = &quot;accessibility-16&quot; / &gt; &lt; . octicon name = &quot;accessibility-inset-16&quot; / &gt; &lt; . octicon name = &quot;alert-16&quot; / &gt; &lt; . octicon name = &quot;alert-24&quot; / &gt; &lt; . octicon name = &quot;alert-fill-12&quot; / &gt; &lt; . octicon name = &quot;alert-fill-16&quot; / &gt; &lt; . octicon name = &quot;alert-fill-24&quot; / &gt; &lt; . octicon name = &quot;apps-16&quot; / &gt; &lt; . octicon name = &quot;archive-16&quot; / &gt; &lt; . octicon name = &quot;archive-24&quot; / &gt; &lt; . octicon name = &quot;arrow-both-16&quot; / &gt; &lt; . octicon name = &quot;arrow-both-24&quot; / &gt; &lt; . octicon name = &quot;arrow-down-16&quot; / &gt; &lt; . octicon name = &quot;arrow-down-24&quot; / &gt; &lt; . octicon name = &quot;arrow-down-left-16&quot; / &gt; &lt; . octicon name = &quot;arrow-down-left-24&quot; / &gt; &lt; . octicon name = &quot;arrow-down-right-16&quot; / &gt; &lt; . octicon name = &quot;arrow-down-right-24&quot; / &gt; &lt; . octicon name = &quot;arrow-left-16&quot; / &gt; &lt; . octicon name = &quot;arrow-left-24&quot; / &gt; &lt; . octicon name = &quot;arrow-right-16&quot; / &gt; &lt; . octicon name = &quot;arrow-right-24&quot; / &gt; &lt; . octicon name = &quot;arrow-switch-16&quot; / &gt; &lt; . octicon name = &quot;arrow-switch-24&quot; / &gt; &lt; . octicon name = &quot;arrow-up-16&quot; / &gt; &lt; . octicon name = &quot;arrow-up-24&quot; / &gt; &lt; . octicon name = &quot;arrow-up-left-16&quot; / &gt; &lt; . octicon name = &quot;arrow-up-left-24&quot; / &gt; &lt; . octicon name = &quot;arrow-up-right-16&quot; / &gt; &lt; . octicon name = &quot;arrow-up-right-24&quot; / &gt; &lt; . octicon name = &quot;beaker-16&quot; / &gt; &lt; . octicon name = &quot;beaker-24&quot; / &gt; &lt; . octicon name = &quot;bell-16&quot; / &gt; &lt; . octicon name = &quot;bell-24&quot; / &gt; &lt; . octicon name = &quot;bell-fill-16&quot; / &gt; &lt; . octicon name = &quot;bell-fill-24&quot; / &gt; &lt; . octicon name = &quot;bell-slash-16&quot; / &gt; &lt; . octicon name = &quot;bell-slash-24&quot; / &gt; &lt; . octicon name = &quot;blocked-16&quot; / &gt; &lt; . octicon name = &quot;blocked-24&quot; / &gt; &lt; . octicon name = &quot;bold-16&quot; / &gt; &lt; . octicon name = &quot;bold-24&quot; / &gt; &lt; . octicon name = &quot;book-16&quot; / &gt; &lt; . octicon name = &quot;book-24&quot; / &gt; &lt; . octicon name = &quot;bookmark-16&quot; / &gt; &lt; . octicon name = &quot;bookmark-24&quot; / &gt; &lt; . octicon name = &quot;bookmark-fill-24&quot; / &gt; &lt; . octicon name = &quot;bookmark-slash-16&quot; / &gt; &lt; . octicon name = &quot;bookmark-slash-24&quot; / &gt; &lt; . octicon name = &quot;bookmark-slash-fill-24&quot; / &gt; &lt; . octicon name = &quot;briefcase-16&quot; / &gt; &lt; . octicon name = &quot;briefcase-24&quot; / &gt; &lt; . octicon name = &quot;broadcast-16&quot; / &gt; &lt; . octicon name = &quot;broadcast-24&quot; / &gt; &lt; . octicon name = &quot;browser-16&quot; / &gt; &lt; . octicon name = &quot;browser-24&quot; / &gt; &lt; . octicon name = &quot;bug-16&quot; / &gt; &lt; . octicon name = &quot;bug-24&quot; / &gt; &lt; . octicon name = &quot;cache-16&quot; / &gt; &lt; . octicon name = &quot;calendar-16&quot; / &gt; &lt; . octicon name = &quot;calendar-24&quot; / &gt; &lt; . octicon name = &quot;check-16&quot; / &gt; &lt; . octicon name = &quot;check-24&quot; / &gt; &lt; . octicon name = &quot;check-circle-16&quot; / &gt; &lt; . octicon name = &quot;check-circle-24&quot; / &gt; &lt; . octicon name = &quot;check-circle-fill-12&quot; / &gt; &lt; . octicon name = &quot;check-circle-fill-16&quot; / &gt; &lt; . octicon name = &quot;check-circle-fill-24&quot; / &gt; &lt; . octicon name = &quot;checkbox-16&quot; / &gt; &lt; . octicon name = &quot;checkbox-24&quot; / &gt; &lt; . octicon name = &quot;checklist-16&quot; / &gt; &lt; . octicon name = &quot;checklist-24&quot; / &gt; &lt; . octicon name = &quot;chevron-down-12&quot; / &gt; &lt; . octicon name = &quot;chevron-down-16&quot; / &gt; &lt; . octicon name = &quot;chevron-down-24&quot; / &gt; &lt; . octicon name = &quot;chevron-left-16&quot; / &gt; &lt; . octicon name = &quot;chevron-left-24&quot; / &gt; &lt; . octicon name = &quot;chevron-right-12&quot; / &gt; &lt; . octicon name = &quot;chevron-right-16&quot; / &gt; &lt; . octicon name = &quot;chevron-right-24&quot; / &gt; &lt; . octicon name = &quot;chevron-up-12&quot; / &gt; &lt; . octicon name = &quot;chevron-up-16&quot; / &gt; &lt; . octicon name = &quot;chevron-up-24&quot; / &gt; &lt; . octicon name = &quot;circle-16&quot; / &gt; &lt; . octicon name = &quot;circle-24&quot; / &gt; &lt; . octicon name = &quot;circle-slash-16&quot; / &gt; &lt; . octicon name = &quot;circle-slash-24&quot; / &gt; &lt; . octicon name = &quot;clock-16&quot; / &gt; &lt; . octicon name = &quot;clock-24&quot; / &gt; &lt; . octicon name = &quot;clock-fill-16&quot; / &gt; &lt; . octicon name = &quot;clock-fill-24&quot; / &gt; &lt; . octicon name = &quot;cloud-16&quot; / &gt; &lt; . octicon name = &quot;cloud-24&quot; / &gt; &lt; . octicon name = &quot;cloud-offline-16&quot; / &gt; &lt; . octicon name = &quot;cloud-offline-24&quot; / &gt; &lt; . octicon name = &quot;code-16&quot; / &gt; &lt; . octicon name = &quot;code-24&quot; / &gt; &lt; . octicon name = &quot;code-of-conduct-16&quot; / &gt; &lt; . octicon name = &quot;code-of-conduct-24&quot; / &gt; &lt; . octicon name = &quot;code-review-16&quot; / &gt; &lt; . octicon name = &quot;code-review-24&quot; / &gt; &lt; . octicon name = &quot;code-square-16&quot; / &gt; &lt; . octicon name = &quot;code-square-24&quot; / &gt; &lt; . octicon name = &quot;codescan-16&quot; / &gt; &lt; . octicon name = &quot;codescan-24&quot; / &gt; &lt; . octicon name = &quot;codescan-checkmark-16&quot; / &gt; &lt; . octicon name = &quot;codescan-checkmark-24&quot; / &gt; &lt; . octicon name = &quot;codespaces-16&quot; / &gt; &lt; . octicon name = &quot;codespaces-24&quot; / &gt; &lt; . octicon name = &quot;columns-16&quot; / &gt; &lt; . octicon name = &quot;columns-24&quot; / &gt; &lt; . octicon name = &quot;command-palette-16&quot; / &gt; &lt; . octicon name = &quot;command-palette-24&quot; / &gt; &lt; . octicon name = &quot;comment-16&quot; / &gt; &lt; . octicon name = &quot;comment-24&quot; / &gt; &lt; . octicon name = &quot;comment-discussion-16&quot; / &gt; &lt; . octicon name = &quot;comment-discussion-24&quot; / &gt; &lt; . octicon name = &quot;commit-24&quot; / &gt; &lt; . octicon name = &quot;container-16&quot; / &gt; &lt; . octicon name = &quot;container-24&quot; / &gt; &lt; . octicon name = &quot;copilot-16&quot; / &gt; &lt; . octicon name = &quot;copilot-24&quot; / &gt; &lt; . octicon name = &quot;copilot-48&quot; / &gt; &lt; . octicon name = &quot;copilot-96&quot; / &gt; &lt; . octicon name = &quot;copilot-error-16&quot; / &gt; &lt; . octicon name = &quot;copilot-warning-16&quot; / &gt; &lt; . octicon name = &quot;copy-16&quot; / &gt; &lt; . octicon name = &quot;copy-24&quot; / &gt; &lt; . octicon name = &quot;cpu-16&quot; / &gt; &lt; . octicon name = &quot;cpu-24&quot; / &gt; &lt; . octicon name = &quot;credit-card-16&quot; / &gt; &lt; . octicon name = &quot;credit-card-24&quot; / &gt; &lt; . octicon name = &quot;cross-reference-16&quot; / &gt; &lt; . octicon name = &quot;cross-reference-24&quot; / &gt; &lt; . octicon name = &quot;dash-16&quot; / &gt; &lt; . octicon name = &quot;dash-24&quot; / &gt; &lt; . octicon name = &quot;database-16&quot; / &gt; &lt; . octicon name = &quot;database-24&quot; / &gt; &lt; . octicon name = &quot;dependabot-16&quot; / &gt; &lt; . octicon name = &quot;dependabot-24&quot; / &gt; &lt; . octicon name = &quot;desktop-download-16&quot; / &gt; &lt; . octicon name = &quot;desktop-download-24&quot; / &gt; &lt; . octicon name = &quot;device-camera-16&quot; / &gt; &lt; . octicon name = &quot;device-camera-video-16&quot; / &gt; &lt; . octicon name = &quot;device-camera-video-24&quot; / &gt; &lt; . octicon name = &quot;device-desktop-16&quot; / &gt; &lt; . octicon name = &quot;device-desktop-24&quot; / &gt; &lt; . octicon name = &quot;device-mobile-16&quot; / &gt; &lt; . octicon name = &quot;device-mobile-24&quot; / &gt; &lt; . octicon name = &quot;diamond-16&quot; / &gt; &lt; . octicon name = &quot;diamond-24&quot; / &gt; &lt; . octicon name = &quot;diff-16&quot; / &gt; &lt; . octicon name = &quot;diff-24&quot; / &gt; &lt; . octicon name = &quot;diff-added-16&quot; / &gt; &lt; . octicon name = &quot;diff-ignored-16&quot; / &gt; &lt; . octicon name = &quot;diff-modified-16&quot; / &gt; &lt; . octicon name = &quot;diff-removed-16&quot; / &gt; &lt; . octicon name = &quot;diff-renamed-16&quot; / &gt; &lt; . octicon name = &quot;discussion-closed-16&quot; / &gt; &lt; . octicon name = &quot;discussion-closed-24&quot; / &gt; &lt; . octicon name = &quot;discussion-duplicate-16&quot; / &gt; &lt; . octicon name = &quot;discussion-duplicate-24&quot; / &gt; &lt; . octicon name = &quot;discussion-outdated-16&quot; / &gt; &lt; . octicon name = &quot;discussion-outdated-24&quot; / &gt; &lt; . octicon name = &quot;dot-16&quot; / &gt; &lt; . octicon name = &quot;dot-24&quot; / &gt; &lt; . octicon name = &quot;dot-fill-16&quot; / &gt; &lt; . octicon name = &quot;dot-fill-24&quot; / &gt; &lt; . octicon name = &quot;download-16&quot; / &gt; &lt; . octicon name = &quot;download-24&quot; / &gt; &lt; . octicon name = &quot;duplicate-16&quot; / &gt; &lt; . octicon name = &quot;duplicate-24&quot; / &gt; &lt; . octicon name = &quot;ellipsis-16&quot; / &gt; &lt; . octicon name = &quot;eye-16&quot; / &gt; &lt; . octicon name = &quot;eye-24&quot; / &gt; &lt; . octicon name = &quot;eye-closed-16&quot; / &gt; &lt; . octicon name = &quot;eye-closed-24&quot; / &gt; &lt; . octicon name = &quot;feed-discussion-16&quot; / &gt; &lt; . octicon name = &quot;feed-forked-16&quot; / &gt; &lt; . octicon name = &quot;feed-heart-16&quot; / &gt; &lt; . octicon name = &quot;feed-merged-16&quot; / &gt; &lt; . octicon name = &quot;feed-person-16&quot; / &gt; &lt; . octicon name = &quot;feed-repo-16&quot; / &gt; &lt; . octicon name = &quot;feed-rocket-16&quot; / &gt; &lt; . octicon name = &quot;feed-star-16&quot; / &gt; &lt; . octicon name = &quot;feed-tag-16&quot; / &gt; &lt; . octicon name = &quot;feed-trophy-16&quot; / &gt; &lt; . octicon name = &quot;file-16&quot; / &gt; &lt; . octicon name = &quot;file-24&quot; / &gt; &lt; . octicon name = &quot;file-added-16&quot; / &gt; &lt; . octicon name = &quot;file-badge-16&quot; / &gt; &lt; . octicon name = &quot;file-binary-16&quot; / &gt; &lt; . octicon name = &quot;file-binary-24&quot; / &gt; &lt; . octicon name = &quot;file-code-16&quot; / &gt; &lt; . octicon name = &quot;file-code-24&quot; / &gt; &lt; . octicon name = &quot;file-diff-16&quot; / &gt; &lt; . octicon name = &quot;file-diff-24&quot; / &gt; &lt; . octicon name = &quot;file-directory-16&quot; / &gt; &lt; . octicon name = &quot;file-directory-24&quot; / &gt; &lt; . octicon name = &quot;file-directory-fill-16&quot; / &gt; &lt; . octicon name = &quot;file-directory-fill-24&quot; / &gt; &lt; . octicon name = &quot;file-directory-open-fill-16&quot; / &gt; &lt; . octicon name = &quot;file-media-24&quot; / &gt; &lt; . octicon name = &quot;file-moved-16&quot; / &gt; &lt; . octicon name = &quot;file-removed-16&quot; / &gt; &lt; . octicon name = &quot;file-submodule-16&quot; / &gt; &lt; . octicon name = &quot;file-submodule-24&quot; / &gt; &lt; . octicon name = &quot;file-symlink-file-16&quot; / &gt; &lt; . octicon name = &quot;file-symlink-file-24&quot; / &gt; &lt; . octicon name = &quot;file-zip-16&quot; / &gt; &lt; . octicon name = &quot;file-zip-24&quot; / &gt; &lt; . octicon name = &quot;filter-16&quot; / &gt; &lt; . octicon name = &quot;filter-24&quot; / &gt; &lt; . octicon name = &quot;fiscal-host-16&quot; / &gt; &lt; . octicon name = &quot;flame-16&quot; / &gt; &lt; . octicon name = &quot;flame-24&quot; / &gt; &lt; . octicon name = &quot;fold-16&quot; / &gt; &lt; . octicon name = &quot;fold-24&quot; / &gt; &lt; . octicon name = &quot;fold-down-16&quot; / &gt; &lt; . octicon name = &quot;fold-down-24&quot; / &gt; &lt; . octicon name = &quot;fold-up-16&quot; / &gt; &lt; . octicon name = &quot;fold-up-24&quot; / &gt; &lt; . octicon name = &quot;gear-16&quot; / &gt; &lt; . octicon name = &quot;gear-24&quot; / &gt; &lt; . octicon name = &quot;gift-16&quot; / &gt; &lt; . octicon name = &quot;gift-24&quot; / &gt; &lt; . octicon name = &quot;git-branch-16&quot; / &gt; &lt; . octicon name = &quot;git-branch-24&quot; / &gt; &lt; . octicon name = &quot;git-commit-16&quot; / &gt; &lt; . octicon name = &quot;git-commit-24&quot; / &gt; &lt; . octicon name = &quot;git-compare-16&quot; / &gt; &lt; . octicon name = &quot;git-compare-24&quot; / &gt; &lt; . octicon name = &quot;git-merge-16&quot; / &gt; &lt; . octicon name = &quot;git-merge-24&quot; / &gt; &lt; . octicon name = &quot;git-merge-queue-16&quot; / &gt; &lt; . octicon name = &quot;git-merge-queue-24&quot; / &gt; &lt; . octicon name = &quot;git-pull-request-16&quot; / &gt; &lt; . octicon name = &quot;git-pull-request-24&quot; / &gt; &lt; . octicon name = &quot;git-pull-request-closed-16&quot; / &gt; &lt; . octicon name = &quot;git-pull-request-closed-24&quot; / &gt; &lt; . octicon name = &quot;git-pull-request-draft-16&quot; / &gt; &lt; . octicon name = &quot;git-pull-request-draft-24&quot; / &gt; &lt; . octicon name = &quot;globe-16&quot; / &gt; &lt; . octicon name = &quot;globe-24&quot; / &gt; &lt; . octicon name = &quot;goal-16&quot; / &gt; &lt; . octicon name = &quot;goal-24&quot; / &gt; &lt; . octicon name = &quot;grabber-16&quot; / &gt; &lt; . octicon name = &quot;grabber-24&quot; / &gt; &lt; . octicon name = &quot;graph-16&quot; / &gt; &lt; . octicon name = &quot;graph-24&quot; / &gt; &lt; . octicon name = &quot;hash-16&quot; / &gt; &lt; . octicon name = &quot;hash-24&quot; / &gt; &lt; . octicon name = &quot;heading-16&quot; / &gt; &lt; . octicon name = &quot;heading-24&quot; / &gt; &lt; . octicon name = &quot;heart-16&quot; / &gt; &lt; . octicon name = &quot;heart-24&quot; / &gt; &lt; . octicon name = &quot;heart-fill-16&quot; / &gt; &lt; . octicon name = &quot;heart-fill-24&quot; / &gt; &lt; . octicon name = &quot;history-16&quot; / &gt; &lt; . octicon name = &quot;history-24&quot; / &gt; &lt; . octicon name = &quot;home-16&quot; / &gt; &lt; . octicon name = &quot;home-24&quot; / &gt; &lt; . octicon name = &quot;home-fill-24&quot; / &gt; &lt; . octicon name = &quot;horizontal-rule-16&quot; / &gt; &lt; . octicon name = &quot;horizontal-rule-24&quot; / &gt; &lt; . octicon name = &quot;hourglass-16&quot; / &gt; &lt; . octicon name = &quot;hourglass-24&quot; / &gt; &lt; . octicon name = &quot;hubot-16&quot; / &gt; &lt; . octicon name = &quot;hubot-24&quot; / &gt; &lt; . octicon name = &quot;id-badge-16&quot; / &gt; &lt; . octicon name = &quot;image-16&quot; / &gt; &lt; . octicon name = &quot;image-24&quot; / &gt; &lt; . octicon name = &quot;inbox-16&quot; / &gt; &lt; . octicon name = &quot;inbox-24&quot; / &gt; &lt; . octicon name = &quot;infinity-16&quot; / &gt; &lt; . octicon name = &quot;infinity-24&quot; / &gt; &lt; . octicon name = &quot;info-16&quot; / &gt; &lt; . octicon name = &quot;info-24&quot; / &gt; &lt; . octicon name = &quot;issue-closed-16&quot; / &gt; &lt; . octicon name = &quot;issue-closed-24&quot; / &gt; &lt; . octicon name = &quot;issue-draft-16&quot; / &gt; &lt; . octicon name = &quot;issue-draft-24&quot; / &gt; &lt; . octicon name = &quot;issue-opened-16&quot; / &gt; &lt; . octicon name = &quot;issue-opened-24&quot; / &gt; &lt; . octicon name = &quot;issue-reopened-16&quot; / &gt; &lt; . octicon name = &quot;issue-reopened-24&quot; / &gt; &lt; . octicon name = &quot;issue-tracked-by-16&quot; / &gt; &lt; . octicon name = &quot;issue-tracked-by-24&quot; / &gt; &lt; . octicon name = &quot;issue-tracks-16&quot; / &gt; &lt; . octicon name = &quot;issue-tracks-24&quot; / &gt; &lt; . octicon name = &quot;italic-16&quot; / &gt; &lt; . octicon name = &quot;italic-24&quot; / &gt; &lt; . octicon name = &quot;iterations-16&quot; / &gt; &lt; . octicon name = &quot;iterations-24&quot; / &gt; &lt; . octicon name = &quot;kebab-horizontal-16&quot; / &gt; &lt; . octicon name = &quot;kebab-horizontal-24&quot; / &gt; &lt; . octicon name = &quot;key-16&quot; / &gt; &lt; . octicon name = &quot;key-24&quot; / &gt; &lt; . octicon name = &quot;key-asterisk-16&quot; / &gt; &lt; . octicon name = &quot;law-16&quot; / &gt; &lt; . octicon name = &quot;law-24&quot; / &gt; &lt; . octicon name = &quot;light-bulb-16&quot; / &gt; &lt; . octicon name = &quot;light-bulb-24&quot; / &gt; &lt; . octicon name = &quot;link-16&quot; / &gt; &lt; . octicon name = &quot;link-24&quot; / &gt; &lt; . octicon name = &quot;link-external-16&quot; / &gt; &lt; . octicon name = &quot;link-external-24&quot; / &gt; &lt; . octicon name = &quot;list-ordered-16&quot; / &gt; &lt; . octicon name = &quot;list-ordered-24&quot; / &gt; &lt; . octicon name = &quot;list-unordered-16&quot; / &gt; &lt; . octicon name = &quot;list-unordered-24&quot; / &gt; &lt; . octicon name = &quot;location-16&quot; / &gt; &lt; . octicon name = &quot;location-24&quot; / &gt; &lt; . octicon name = &quot;lock-16&quot; / &gt; &lt; . octicon name = &quot;lock-24&quot; / &gt; &lt; . octicon name = &quot;log-16&quot; / &gt; &lt; . octicon name = &quot;log-24&quot; / &gt; &lt; . octicon name = &quot;logo-gist-16&quot; / &gt; &lt; . octicon name = &quot;logo-github-16&quot; / &gt; &lt; . octicon name = &quot;mail-16&quot; / &gt; &lt; . octicon name = &quot;mail-24&quot; / &gt; &lt; . octicon name = &quot;mark-github-16&quot; / &gt; &lt; . octicon name = &quot;markdown-16&quot; / &gt; &lt; . octicon name = &quot;megaphone-16&quot; / &gt; &lt; . octicon name = &quot;megaphone-24&quot; / &gt; &lt; . octicon name = &quot;mention-16&quot; / &gt; &lt; . octicon name = &quot;mention-24&quot; / &gt; &lt; . octicon name = &quot;meter-16&quot; / &gt; &lt; . octicon name = &quot;milestone-16&quot; / &gt; &lt; . octicon name = &quot;milestone-24&quot; / &gt; &lt; . octicon name = &quot;mirror-16&quot; / &gt; &lt; . octicon name = &quot;mirror-24&quot; / &gt; &lt; . octicon name = &quot;moon-16&quot; / &gt; &lt; . octicon name = &quot;moon-24&quot; / &gt; &lt; . octicon name = &quot;mortar-board-16&quot; / &gt; &lt; . octicon name = &quot;mortar-board-24&quot; / &gt; &lt; . octicon name = &quot;move-to-bottom-16&quot; / &gt; &lt; . octicon name = &quot;move-to-bottom-24&quot; / &gt; &lt; . octicon name = &quot;move-to-end-16&quot; / &gt; &lt; . octicon name = &quot;move-to-end-24&quot; / &gt; &lt; . octicon name = &quot;move-to-start-16&quot; / &gt; &lt; . octicon name = &quot;move-to-start-24&quot; / &gt; &lt; . octicon name = &quot;move-to-top-16&quot; / &gt; &lt; . octicon name = &quot;move-to-top-24&quot; / &gt; &lt; . octicon name = &quot;multi-select-16&quot; / &gt; &lt; . octicon name = &quot;multi-select-24&quot; / &gt; &lt; . octicon name = &quot;mute-16&quot; / &gt; &lt; . octicon name = &quot;mute-24&quot; / &gt; &lt; . octicon name = &quot;no-entry-16&quot; / &gt; &lt; . octicon name = &quot;no-entry-24&quot; / &gt; &lt; . octicon name = &quot;no-entry-fill-12&quot; / &gt; &lt; . octicon name = &quot;north-star-16&quot; / &gt; &lt; . octicon name = &quot;north-star-24&quot; / &gt; &lt; . octicon name = &quot;note-16&quot; / &gt; &lt; . octicon name = &quot;note-24&quot; / &gt; &lt; . octicon name = &quot;number-16&quot; / &gt; &lt; . octicon name = &quot;number-24&quot; / &gt; &lt; . octicon name = &quot;organization-16&quot; / &gt; &lt; . octicon name = &quot;organization-24&quot; / &gt; &lt; . octicon name = &quot;package-16&quot; / &gt; &lt; . octicon name = &quot;package-24&quot; / &gt; &lt; . octicon name = &quot;package-dependencies-16&quot; / &gt; &lt; . octicon name = &quot;package-dependencies-24&quot; / &gt; &lt; . octicon name = &quot;package-dependents-16&quot; / &gt; &lt; . octicon name = &quot;package-dependents-24&quot; / &gt; &lt; . octicon name = &quot;paintbrush-16&quot; / &gt; &lt; . octicon name = &quot;paper-airplane-16&quot; / &gt; &lt; . octicon name = &quot;paper-airplane-24&quot; / &gt; &lt; . octicon name = &quot;paperclip-16&quot; / &gt; &lt; . octicon name = &quot;paperclip-24&quot; / &gt; &lt; . octicon name = &quot;passkey-fill-16&quot; / &gt; &lt; . octicon name = &quot;passkey-fill-24&quot; / &gt; &lt; . octicon name = &quot;paste-16&quot; / &gt; &lt; . octicon name = &quot;paste-24&quot; / &gt; &lt; . octicon name = &quot;pencil-16&quot; / &gt; &lt; . octicon name = &quot;pencil-24&quot; / &gt; &lt; . octicon name = &quot;people-16&quot; / &gt; &lt; . octicon name = &quot;people-24&quot; / &gt; &lt; . octicon name = &quot;person-16&quot; / &gt; &lt; . octicon name = &quot;person-24&quot; / &gt; &lt; . octicon name = &quot;person-add-16&quot; / &gt; &lt; . octicon name = &quot;person-add-24&quot; / &gt; &lt; . octicon name = &quot;person-fill-16&quot; / &gt; &lt; . octicon name = &quot;person-fill-24&quot; / &gt; &lt; . octicon name = &quot;pin-16&quot; / &gt; &lt; . octicon name = &quot;pin-24&quot; / &gt; &lt; . octicon name = &quot;play-16&quot; / &gt; &lt; . octicon name = &quot;play-24&quot; / &gt; &lt; . octicon name = &quot;plug-16&quot; / &gt; &lt; . octicon name = &quot;plug-24&quot; / &gt; &lt; . octicon name = &quot;plus-16&quot; / &gt; &lt; . octicon name = &quot;plus-24&quot; / &gt; &lt; . octicon name = &quot;plus-circle-16&quot; / &gt; &lt; . octicon name = &quot;plus-circle-24&quot; / &gt; &lt; . octicon name = &quot;project-16&quot; / &gt; &lt; . octicon name = &quot;project-24&quot; / &gt; &lt; . octicon name = &quot;project-roadmap-16&quot; / &gt; &lt; . octicon name = &quot;project-roadmap-24&quot; / &gt; &lt; . octicon name = &quot;project-symlink-16&quot; / &gt; &lt; . octicon name = &quot;project-symlink-24&quot; / &gt; &lt; . octicon name = &quot;pulse-16&quot; / &gt; &lt; . octicon name = &quot;pulse-24&quot; / &gt; &lt; . octicon name = &quot;question-16&quot; / &gt; &lt; . octicon name = &quot;question-24&quot; / &gt; &lt; . octicon name = &quot;quote-16&quot; / &gt; &lt; . octicon name = &quot;quote-24&quot; / &gt; &lt; . octicon name = &quot;read-16&quot; / &gt; &lt; . octicon name = &quot;read-24&quot; / &gt; &lt; . octicon name = &quot;rel-file-path-16&quot; / &gt; &lt; . octicon name = &quot;rel-file-path-24&quot; / &gt; &lt; . octicon name = &quot;reply-16&quot; / &gt; &lt; . octicon name = &quot;reply-24&quot; / &gt; &lt; . octicon name = &quot;repo-16&quot; / &gt; &lt; . octicon name = &quot;repo-24&quot; / &gt; &lt; . octicon name = &quot;repo-clone-16&quot; / &gt; &lt; . octicon name = &quot;repo-deleted-16&quot; / &gt; &lt; . octicon name = &quot;repo-forked-16&quot; / &gt; &lt; . octicon name = &quot;repo-forked-24&quot; / &gt; &lt; . octicon name = &quot;repo-locked-16&quot; / &gt; &lt; . octicon name = &quot;repo-locked-24&quot; / &gt; &lt; . octicon name = &quot;repo-pull-16&quot; / &gt; &lt; . octicon name = &quot;repo-push-16&quot; / &gt; &lt; . octicon name = &quot;repo-push-24&quot; / &gt; &lt; . octicon name = &quot;repo-template-16&quot; / &gt; &lt; . octicon name = &quot;repo-template-24&quot; / &gt; &lt; . octicon name = &quot;report-16&quot; / &gt; &lt; . octicon name = &quot;report-24&quot; / &gt; &lt; . octicon name = &quot;rocket-16&quot; / &gt; &lt; . octicon name = &quot;rocket-24&quot; / &gt; &lt; . octicon name = &quot;rows-16&quot; / &gt; &lt; . octicon name = &quot;rows-24&quot; / &gt; &lt; . octicon name = &quot;rss-16&quot; / &gt; &lt; . octicon name = &quot;rss-24&quot; / &gt; &lt; . octicon name = &quot;ruby-16&quot; / &gt; &lt; . octicon name = &quot;ruby-24&quot; / &gt; &lt; . octicon name = &quot;screen-full-16&quot; / &gt; &lt; . octicon name = &quot;screen-full-24&quot; / &gt; &lt; . octicon name = &quot;screen-normal-16&quot; / &gt; &lt; . octicon name = &quot;screen-normal-24&quot; / &gt; &lt; . octicon name = &quot;search-16&quot; / &gt; &lt; . octicon name = &quot;search-24&quot; / &gt; &lt; . octicon name = &quot;server-16&quot; / &gt; &lt; . octicon name = &quot;server-24&quot; / &gt; &lt; . octicon name = &quot;share-16&quot; / &gt; &lt; . octicon name = &quot;share-24&quot; / &gt; &lt; . octicon name = &quot;share-android-16&quot; / &gt; &lt; . octicon name = &quot;share-android-24&quot; / &gt; &lt; . octicon name = &quot;shield-16&quot; / &gt; &lt; . octicon name = &quot;shield-24&quot; / &gt; &lt; . octicon name = &quot;shield-check-16&quot; / &gt; &lt; . octicon name = &quot;shield-check-24&quot; / &gt; &lt; . octicon name = &quot;shield-lock-16&quot; / &gt; &lt; . octicon name = &quot;shield-lock-24&quot; / &gt; &lt; . octicon name = &quot;shield-slash-16&quot; / &gt; &lt; . octicon name = &quot;shield-slash-24&quot; / &gt; &lt; . octicon name = &quot;shield-x-16&quot; / &gt; &lt; . octicon name = &quot;shield-x-24&quot; / &gt; &lt; . octicon name = &quot;sidebar-collapse-16&quot; / &gt; &lt; . octicon name = &quot;sidebar-collapse-24&quot; / &gt; &lt; . octicon name = &quot;sidebar-expand-16&quot; / &gt; &lt; . octicon name = &quot;sidebar-expand-24&quot; / &gt; &lt; . octicon name = &quot;sign-in-16&quot; / &gt; &lt; . octicon name = &quot;sign-in-24&quot; / &gt; &lt; . octicon name = &quot;sign-out-16&quot; / &gt; &lt; . octicon name = &quot;sign-out-24&quot; / &gt; &lt; . octicon name = &quot;single-select-16&quot; / &gt; &lt; . octicon name = &quot;single-select-24&quot; / &gt; &lt; . octicon name = &quot;skip-16&quot; / &gt; &lt; . octicon name = &quot;skip-24&quot; / &gt; &lt; . octicon name = &quot;skip-fill-16&quot; / &gt; &lt; . octicon name = &quot;skip-fill-24&quot; / &gt; &lt; . octicon name = &quot;sliders-16&quot; / &gt; &lt; . octicon name = &quot;smiley-16&quot; / &gt; &lt; . octicon name = &quot;smiley-24&quot; / &gt; &lt; . octicon name = &quot;sort-asc-16&quot; / &gt; &lt; . octicon name = &quot;sort-asc-24&quot; / &gt; &lt; . octicon name = &quot;sort-desc-16&quot; / &gt; &lt; . octicon name = &quot;sort-desc-24&quot; / &gt; &lt; . octicon name = &quot;sparkle-fill-16&quot; / &gt; &lt; . octicon name = &quot;sponsor-tiers-16&quot; / &gt; &lt; . octicon name = &quot;sponsor-tiers-24&quot; / &gt; &lt; . octicon name = &quot;square-16&quot; / &gt; &lt; . octicon name = &quot;square-24&quot; / &gt; &lt; . octicon name = &quot;square-fill-16&quot; / &gt; &lt; . octicon name = &quot;square-fill-24&quot; / &gt; &lt; . octicon name = &quot;squirrel-16&quot; / &gt; &lt; . octicon name = &quot;squirrel-24&quot; / &gt; &lt; . octicon name = &quot;stack-16&quot; / &gt; &lt; . octicon name = &quot;stack-24&quot; / &gt; &lt; . octicon name = &quot;star-16&quot; / &gt; &lt; . octicon name = &quot;star-24&quot; / &gt; &lt; . octicon name = &quot;star-fill-16&quot; / &gt; &lt; . octicon name = &quot;star-fill-24&quot; / &gt; &lt; . octicon name = &quot;stop-16&quot; / &gt; &lt; . octicon name = &quot;stop-24&quot; / &gt; &lt; . octicon name = &quot;stopwatch-16&quot; / &gt; &lt; . octicon name = &quot;stopwatch-24&quot; / &gt; &lt; . octicon name = &quot;strikethrough-16&quot; / &gt; &lt; . octicon name = &quot;strikethrough-24&quot; / &gt; &lt; . octicon name = &quot;sun-16&quot; / &gt; &lt; . octicon name = &quot;sun-24&quot; / &gt; &lt; . octicon name = &quot;sync-16&quot; / &gt; &lt; . octicon name = &quot;sync-24&quot; / &gt; &lt; . octicon name = &quot;tab-24&quot; / &gt; &lt; . octicon name = &quot;tab-external-16&quot; / &gt; &lt; . octicon name = &quot;table-16&quot; / &gt; &lt; . octicon name = &quot;table-24&quot; / &gt; &lt; . octicon name = &quot;tag-16&quot; / &gt; &lt; . octicon name = &quot;tag-24&quot; / &gt; &lt; . octicon name = &quot;tasklist-16&quot; / &gt; &lt; . octicon name = &quot;tasklist-24&quot; / &gt; &lt; . octicon name = &quot;telescope-16&quot; / &gt; &lt; . octicon name = &quot;telescope-24&quot; / &gt; &lt; . octicon name = &quot;telescope-fill-16&quot; / &gt; &lt; . octicon name = &quot;telescope-fill-24&quot; / &gt; &lt; . octicon name = &quot;terminal-16&quot; / &gt; &lt; . octicon name = &quot;terminal-24&quot; / &gt; &lt; . octicon name = &quot;three-bars-16&quot; / &gt; &lt; . octicon name = &quot;thumbsdown-16&quot; / &gt; &lt; . octicon name = &quot;thumbsdown-24&quot; / &gt; &lt; . octicon name = &quot;thumbsup-16&quot; / &gt; &lt; . octicon name = &quot;thumbsup-24&quot; / &gt; &lt; . octicon name = &quot;tools-16&quot; / &gt; &lt; . octicon name = &quot;tools-24&quot; / &gt; &lt; . octicon name = &quot;trash-16&quot; / &gt; &lt; . octicon name = &quot;trash-24&quot; / &gt; &lt; . octicon name = &quot;triangle-down-16&quot; / &gt; &lt; . octicon name = &quot;triangle-down-24&quot; / &gt; &lt; . octicon name = &quot;triangle-left-16&quot; / &gt; &lt; . octicon name = &quot;triangle-left-24&quot; / &gt; &lt; . octicon name = &quot;triangle-right-16&quot; / &gt; &lt; . octicon name = &quot;triangle-right-24&quot; / &gt; &lt; . octicon name = &quot;triangle-up-16&quot; / &gt; &lt; . octicon name = &quot;triangle-up-24&quot; / &gt; &lt; . octicon name = &quot;trophy-16&quot; / &gt; &lt; . octicon name = &quot;trophy-24&quot; / &gt; &lt; . octicon name = &quot;typography-16&quot; / &gt; &lt; . octicon name = &quot;typography-24&quot; / &gt; &lt; . octicon name = &quot;unfold-16&quot; / &gt; &lt; . octicon name = &quot;unfold-24&quot; / &gt; &lt; . octicon name = &quot;unlink-16&quot; / &gt; &lt; . octicon name = &quot;unlink-24&quot; / &gt; &lt; . octicon name = &quot;unlock-16&quot; / &gt; &lt; . octicon name = &quot;unlock-24&quot; / &gt; &lt; . octicon name = &quot;unmute-16&quot; / &gt; &lt; . octicon name = &quot;unmute-24&quot; / &gt; &lt; . octicon name = &quot;unread-16&quot; / &gt; &lt; . octicon name = &quot;unread-24&quot; / &gt; &lt; . octicon name = &quot;unverified-16&quot; / &gt; &lt; . octicon name = &quot;unverified-24&quot; / &gt; &lt; . octicon name = &quot;upload-16&quot; / &gt; &lt; . octicon name = &quot;upload-24&quot; / &gt; &lt; . octicon name = &quot;verified-16&quot; / &gt; &lt; . octicon name = &quot;verified-24&quot; / &gt; &lt; . octicon name = &quot;versions-16&quot; / &gt; &lt; . octicon name = &quot;versions-24&quot; / &gt; &lt; . octicon name = &quot;video-16&quot; / &gt; &lt; . octicon name = &quot;video-24&quot; / &gt; &lt; . octicon name = &quot;webhook-16&quot; / &gt; &lt; . octicon name = &quot;workflow-16&quot; / &gt; &lt; . octicon name = &quot;workflow-24&quot; / &gt; &lt; . octicon name = &quot;x-16&quot; / &gt; &lt; . octicon name = &quot;x-24&quot; / &gt; &lt; . octicon name = &quot;x-circle-16&quot; / &gt; &lt; . octicon name = &quot;x-circle-24&quot; / &gt; &lt; . octicon name = &quot;x-circle-fill-12&quot; / &gt; &lt; . octicon name = &quot;x-circle-fill-16&quot; / &gt; &lt; . octicon name = &quot;x-circle-fill-24&quot; / &gt; &lt; . octicon name = &quot;zap-16&quot; / &gt; &lt; . octicon name = &quot;zap-24&quot; / &gt; &lt; . octicon name = &quot;zoom-in-16&quot; / &gt; &lt; . octicon name = &quot;zoom-in-24&quot; / &gt; &lt; . octicon name = &quot;zoom-out-16&quot; / &gt; &lt; . octicon name = &quot;zoom-out-24&quot; / &gt;","ref":"PrimerLive.Octicons.html#octicons/1","title":"PrimerLive.Octicons.octicons/1","type":"function"},{"doc":"Primer CSS contains styles for light/dark color modes and themes, with support for color blindness. PrimerLive provides components and functions to work with themes: theme/1 - wrapper to set the theme on child elements theme_menu_options/1 - contents for a theme menu html_attributes/2 - HTML attributes to set a theme on a component or element directly Persistency There is no easy way to save persistent session data in LiveView because LiveView's state is stored in a process that ends when the page is left. The solution is to use an Ajax request to our Phoenix app, which updates the session. This setup involves 5 steps, but the provided helper functions make it a bit easier. 1. Create a SessionController Create file controllers/session_controller.ex : defmodule MyAppWeb.SessionController do use MyAppWeb , :controller use PrimerLive.ThemeSessionController end PrimerLive.ThemeSessionController will add the received theme request data to the session. 2. Add SessionController to the router's api scope &quot;/api&quot; , MyAppWeb do pipe_through :api post PrimerLive.Theme . session_route ( ) , SessionController , :set end Optionally set the max_age in endpoint.ex : @session_options [ ... # Over 300 years. max_age : 9_999_999_999 ] 3. Add ThemeMenu hook In app.js , import ThemeMenu and add it to the liveSocket hooks: import { Prompt , ThemeMenu } from &#39;primer-live&#39; ; const hooks = { } ; hooks . Prompt = Prompt ; hooks . ThemeMenu = ThemeMenu ; let liveSocket = new LiveSocket ( &#39;/live&#39; , Socket , { params : { _csrf_token : csrfToken } , hooks , } ) ; You may the hook anywhere, but only once for the entire application. If you have a single theme menu, add it there: &lt; . action_menu phx - hook = &quot;ThemeMenu&quot; id = &quot;theme_menu&quot; &gt; ... &lt; / . action_menu &gt; 4. Initialise the theme from session data In the LiveView's mount , call add_to_socket : def mount ( _params , session , socket ) do socket = socket |&gt; PrimerLive.Theme . add_to_socket ( session ) { :ok , socket } end This reads the theme state and adds it to the socket assigns. Optionally set the default theme in the seconds argument: PrimerLive.Theme . add_to_socket ( session , %{ color_mode : &quot;light&quot; , light_theme : &quot;light&quot; , dark_theme : &quot;dark&quot; } ) 5. Handle update events In the LiveView where the action menu resides, add: use PrimerLive.ThemeEvent This implements function handle_event for &quot;update_theme&quot; (which is called by clicks on the menu's action_list items). The function updates the socket and sends the event that is picked by by JavaScript (via the ThemeMenu hook).","ref":"PrimerLive.Theme.html","title":"PrimerLive.Theme","type":"module"},{"doc":"See add_to_socket/3 .","ref":"PrimerLive.Theme.html#add_to_socket/2","title":"PrimerLive.Theme.add_to_socket/2","type":"function"},{"doc":"Adds theme_state and default_theme_state to socket.assigns .","ref":"PrimerLive.Theme.html#add_to_socket/3","title":"PrimerLive.Theme.add_to_socket/3","type":"function"},{"doc":"Configures menu options from supplied params: theme: the current theme state (used to define the selected menu items) menu_options: which menu options will be displayed menu_labels: overrides of default text labels Returns a list with 3 menu elements: color_mode dark_theme light_theme Each list item is a map that contains display attributes: group label option labels the selected item Tests iex&gt; PrimerLive.Theme . create_menu_items ( ...&gt; %{ ...&gt; color_mode : &quot;light&quot; , ...&gt; light_theme : &quot;light_high_contrast&quot; , ...&gt; dark_theme : &quot;dark_high_contrast&quot; ...&gt; } , ...&gt; PrimerLive.Theme . default_menu_options ( ) , ...&gt; PrimerLive.Theme . default_menu_labels ( ) ...&gt; ) [ color_mode : %{ labeled_options : [ { &quot;light&quot; , &quot;Light&quot; } , { &quot;dark&quot; , &quot;Dark&quot; } , { &quot;auto&quot; , &quot;System&quot; } ] , options : [ &quot;light&quot; , &quot;dark&quot; , &quot;auto&quot; ] , selected : &quot;light&quot; , title : &quot;Theme&quot; } , dark_theme : %{ labeled_options : [ { &quot;dark&quot; , &quot;Dark&quot; } , { &quot;dark_dimmed&quot; , &quot;Dark dimmed&quot; } , { &quot;dark_high_contrast&quot; , &quot;Dark high contrast&quot; } , { &quot;dark_colorblind&quot; , &quot;Dark colorblind&quot; } , { &quot;dark_tritanopia&quot; , &quot;Dark Tritanopia&quot; } ] , options : [ &quot;dark&quot; , &quot;dark_dimmed&quot; , &quot;dark_high_contrast&quot; , &quot;dark_colorblind&quot; , &quot;dark_tritanopia&quot; ] , selected : &quot;dark_high_contrast&quot; , title : &quot;Dark tone&quot; } , light_theme : %{ labeled_options : [ { &quot;light&quot; , &quot;Light&quot; } , { &quot;light_high_contrast&quot; , &quot;Light high contrast&quot; } , { &quot;light_colorblind&quot; , &quot;Light colorblind&quot; } , { &quot;light_tritanopia&quot; , &quot;Light Tritanopia&quot; } ] , options : [ &quot;light&quot; , &quot;light_high_contrast&quot; , &quot;light_colorblind&quot; , &quot;light_tritanopia&quot; ] , selected : &quot;light_high_contrast&quot; , title : &quot;Light tone&quot; } ] iex&gt; PrimerLive.Theme . create_menu_items ( ...&gt; %{ ...&gt; color_mode : &quot;light&quot; , ...&gt; light_theme : &quot;light_high_contrast&quot; , ...&gt; dark_theme : &quot;dark_high_contrast&quot; ...&gt; } , ...&gt; %{ ...&gt; color_mode : ~w(light dark) ...&gt; } , ...&gt; %{ ...&gt; color_mode : %{ ...&gt; light : &quot;Light theme&quot; ...&gt; } , ...&gt; reset : &quot;Reset&quot; ...&gt; } ) [ color_mode : %{ labeled_options : [ { &quot;light&quot; , &quot;Light theme&quot; } , { &quot;dark&quot; , &quot;Dark&quot; } ] , options : [ &quot;light&quot; , &quot;dark&quot; ] , selected : &quot;light&quot; , title : &quot;Theme&quot; } ]","ref":"PrimerLive.Theme.html#create_menu_items/3","title":"PrimerLive.Theme.create_menu_items/3","type":"function"},{"doc":"Default label for a theme menu.","ref":"PrimerLive.Theme.html#default_menu_labels/0","title":"PrimerLive.Theme.default_menu_labels/0","type":"function"},{"doc":"Default options for a theme menu.","ref":"PrimerLive.Theme.html#default_menu_options/0","title":"PrimerLive.Theme.default_menu_options/0","type":"function"},{"doc":"Initial theme state.","ref":"PrimerLive.Theme.html#default_theme_state/0","title":"PrimerLive.Theme.default_theme_state/0","type":"function"},{"doc":"See html_attributes/2 .","ref":"PrimerLive.Theme.html#html_attributes/1","title":"PrimerLive.Theme.html_attributes/1","type":"function"},{"doc":"Creates HTML (data) attributes from the supplied theme state to set a theme on a component or element directly: &lt; . button { PrimerLive.Theme . html_attributes ( [ color_mode : &quot;dark&quot; , dark_theme : &quot;dark_high_contrast&quot; ] ) } &gt; Button &lt; / . button &gt; &lt; . octicon name = &quot;sun-24&quot; { PrimerLive.Theme . html_attributes ( %{ color_mode : &quot;dark&quot; , dark_theme : &quot;dark_dimmed&quot; } ) } / &gt; Tests iex&gt; PrimerLive.Theme . html_attributes ( ...&gt; %{ ...&gt; color_mode : &quot;light&quot; , ...&gt; light_theme : &quot;light_high_contrast&quot; , ...&gt; dark_theme : &quot;dark_high_contrast&quot; ...&gt; } ...&gt; ) [ data_color_mode : &quot;light&quot; , data_light_theme : &quot;light_high_contrast&quot; , data_dark_theme : &quot;dark_high_contrast&quot; ] iex&gt; PrimerLive.Theme . html_attributes ( ...&gt; %{ ...&gt; } , ...&gt; %{ ...&gt; color_mode : &quot;auto&quot; , ...&gt; light_theme : &quot;light&quot; , ...&gt; dark_theme : &quot;dark&quot; ...&gt; } ...&gt; ) [ data_color_mode : &quot;auto&quot; , data_light_theme : &quot;light&quot; , data_dark_theme : &quot;dark&quot; ] iex&gt; PrimerLive.Theme . html_attributes ( ...&gt; %{ ...&gt; light_theme : &quot;light_high_contrast&quot; , ...&gt; } , ...&gt; %{ ...&gt; color_mode : &quot;auto&quot; , ...&gt; light_theme : &quot;light&quot; , ...&gt; dark_theme : &quot;dark&quot; ...&gt; } ...&gt; ) [ data_color_mode : &quot;auto&quot; , data_light_theme : &quot;light_high_contrast&quot; , data_dark_theme : &quot;dark&quot; ] iex&gt; PrimerLive.Theme . html_attributes ( ...&gt; %{ ...&gt; } , ...&gt; %{ ...&gt; color_mode : &quot;auto&quot; , ...&gt; } ...&gt; ) [ data_color_mode : &quot;auto&quot; ]","ref":"PrimerLive.Theme.html#html_attributes/2","title":"PrimerLive.Theme.html_attributes/2","type":"function"},{"doc":"Compares the supplied state with the supplied default state. Tests iex&gt; PrimerLive.Theme . is_default_theme ( ...&gt; %{ ...&gt; color_mode : &quot;auto&quot; , ...&gt; light_theme : &quot;light&quot; , ...&gt; dark_theme : &quot;dark&quot; ...&gt; } , ...&gt; PrimerLive.Theme . default_theme_state ( ) ...&gt; ) true iex&gt; PrimerLive.Theme . is_default_theme ( ...&gt; %{ ...&gt; color_mode : &quot;light&quot; , ...&gt; light_theme : &quot;light_high_contrast&quot; , ...&gt; dark_theme : &quot;dark_high_contrast&quot; ...&gt; } , ...&gt; PrimerLive.Theme . default_theme_state ( ) ...&gt; ) false","ref":"PrimerLive.Theme.html#is_default_theme/2","title":"PrimerLive.Theme.is_default_theme/2","type":"function"},{"doc":"Internal use. Reset link identifier to distinguish in update.","ref":"PrimerLive.Theme.html#reset_key/0","title":"PrimerLive.Theme.reset_key/0","type":"function"},{"doc":"Generic key used for: session route JS event name (&quot;phx:&quot; prefix is assigned automatically)","ref":"PrimerLive.Theme.html#session_key/0","title":"PrimerLive.Theme.session_key/0","type":"function"},{"doc":"Route for session api calls. For example: scope &quot;/api&quot; , MyAppWeb do pipe_through :api post PrimerLive.Theme . session_route ( ) , SessionController , :set end","ref":"PrimerLive.Theme.html#session_route/0","title":"PrimerLive.Theme.session_route/0","type":"function"},{"doc":"Theme data stored in the session.","ref":"PrimerLive.Theme.html#session_theme_key/0","title":"PrimerLive.Theme.session_theme_key/0","type":"function"},{"doc":"Returns an updated theme state by putting the supplied data in the theme state. If key is the reset key, returns the default theme state.","ref":"PrimerLive.Theme.html#update/3","title":"PrimerLive.Theme.update/3","type":"function"},{"doc":"Internal use. Update link identifier.","ref":"PrimerLive.Theme.html#update_theme_event_key/0","title":"PrimerLive.Theme.update_theme_event_key/0","type":"function"},{"doc":"Handles update events from a theme menu.","ref":"PrimerLive.ThemeEvent.html","title":"PrimerLive.ThemeEvent","type":"module"},{"doc":"Handles api calls to /api/theme . Usage: Create file controllers/session_controller.ex : defmodule MyAppWeb.SessionController do use MyAppWeb , :controller use PrimerLive.ThemeSessionController end","ref":"PrimerLive.ThemeSessionController.html","title":"PrimerLive.ThemeSessionController","type":"module"},{"doc":"Interface icons that are not part of the Octicons set.","ref":"PrimerLive.UIIcons.html","title":"PrimerLive.UIIcons","type":"module"},{"doc":"Internal use: generates a map of SVG's. To use the PrimerLive.Component.ui_icon/1 component, write: &lt; . ui_icon name = &quot;icon-name&quot; / &gt; All UI icons &lt; . ui_icon name = &quot;single-select-16&quot; / &gt; &lt; . ui_icon name = &quot;multiple-select-16&quot; / &gt; &lt; . ui_icon name = &quot;collapse-16&quot; / &gt; Attributes Global attributes are accepted.","ref":"PrimerLive.UIIcons.html#ui_icons/1","title":"PrimerLive.UIIcons.ui_icons/1","type":"function"},{"doc":"Copyright Arthur Clemens Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]